=== removed directory '.bzr-builddeb'
=== removed file '.bzr-builddeb/default.conf'
--- .bzr-builddeb/default.conf	2008-09-17 00:34:09 +0000
+++ .bzr-builddeb/default.conf	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-[BUILDDEB]
-split = True

=== modified file '.bzrignore'
--- .bzrignore	2008-09-06 16:33:54 +0000
+++ .bzrignore	2008-08-27 01:18:25 +0000
@@ -3,6 +3,6 @@
 *.8mandos
 plugin-runner
 plugins.d/password-prompt
-plugins.d/mandos-client
+plugins.d/password-request
 confdir
 keydir

=== removed file 'INSTALL'
--- INSTALL	2008-09-08 18:54:47 +0000
+++ INSTALL	1970-01-01 00:00:00 +0000
@@ -1,114 +0,0 @@
--*- org -*-
-
-* Prerequisites
-  
-** Operating System
-   
-   Debian 5.0 "lenny" or Ubuntu 8.04 "Hardy Heron".
-   
-   This is mostly for the support scripts which make sure that the
-   client is installed and started in the initial RAM disk environment
-   and that the initrd.img file is automatically made unreadable.  The
-   server and client programs themselves *could* be run in other
-   distributions, but they *are* specific to GNU/Linux systems, and
-   are not intended to be portable to other Unixes.
-  
-** Libraries
-   
-   The following libraries and packages are needed.  (It is possible
-   that it might work with older versions of some of these, but these
-   versions are confirmed to work.  Newer versions are almost
-   certainly OK.)
-   
-*** Documentation
-    These are required to build the manual pages for both the server
-    and client:
-    
-    + DocBook 4.5         http://www.docbook.org/
-      Note: DocBook 5.0 is not compatible.
-    + DocBook XSL stylesheets 1.71.0
-                   http://wiki.docbook.org/topic/DocBookXslStylesheets
-    
-    Package names:
-    docbook docbook-xsl
-    
-    To build just the documentation, run the command "make doc".  Then
-    the manual page "mandos.8", for example, can be read by running
-    "man -l mandos.8".
-   
-*** Mandos Server
-    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
-    + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.4          http://www.python.org/
-    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
-    + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
-    
-    Strongly recommended:
-    + fping 2.4b2-to-ipv6 http://www.fping.com/
-    
-    Package names:
-    python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes
-   
-*** Mandos Client
-    + initramfs-tools 0.85i
-                  http://packages.qa.debian.org/i/initramfs-tools.html
-    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
-    + Avahi 0.6.16        http://www.avahi.org/
-    + GnuPG 1.4.9         http://www.gnupg.org/
-    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
-    
-    Package names:
-    initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev
-
-* Installing the Mandos server
-  
-  1. Do "make doc".
-  
-  2. On the computer to run as a Mandos server, run the following
-     command:
-     For Debian: su -c 'make install-server'
-     For Ubuntu: sudo make install-server
-     
-     (This creates a configuration without any clients configured; you
-     need an actually configured client to do that; see below.)
-
-* Installing the Mandos client.
-  
-  1. Do "make all doc".
-  
-  2. On the computer to run as a Mandos client, run the following
-     command:
-     For Debian: su -c 'make install-client'
-     For Ubuntu: sudo make install-client
-     
-     This will also create an OpenPGP key, which will take some time
-     and entropy, so be patient.
-  
-  3. Run the following command:
-     For Debian: su -c 'mandos-keygen --password'
-     For Ubuntu: sudo mandos-keygen --password
-     
-     When prompted, enter the password/passphrase for the encrypted
-     root file system on this client computer.  The command will
-     output a section of text, starting with a [section header].  Copy
-     and append this to the file "/etc/mandos/clients.conf" *on the
-     server computer*.
-  
-  4. On the server computer, start the server by running the command
-     For Debian: su -c 'invoke-rc.d mandos start'
-     For Ubuntu: sudo invoke-rc.d mandos start
-     
-     After this, the client computer should be able to reboot without
-     needing a password entered on the console, as long as it does not
-     take more than an hour to reboot.
-
-* Further customizations
-  
-  You may want to tighten or loosen the timeouts in the server
-  configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  Is IPsec is not used, it is suggested that a more cryptographically
-  secure checker program is used and configured, since without IPsec
-  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2008-09-17 00:34:09 +0000
+++ Makefile	2008-09-03 05:04:40 +0000
@@ -4,31 +4,21 @@
 	-Wunsafe-loop-optimizations -Wpointer-arith \
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
-	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
-#DEBUG=-ggdb3
+	-Wpacked -Wnested-externs -Wunreachable-code -Winline \
+	-Wvolatile-register-var
+DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
 FORTIFY=-D_FORTIFY_SOURCE=2 # -fstack-protector-all
 #COVERAGE=--coverage
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
-
-## Use these settings for a traditional /usr/local install
-# PREFIX=$(DESTDIR)/usr/local
-# CONFDIR=$(DESTDIR)/etc/mandos
-# KEYDIR=$(DESTDIR)/etc/mandos/keys
-# MANDIR=$(PREFIX)/man
-# INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
-##
-
-## These settings are for a package-type install
+# PREFIX=/usr/local
 PREFIX=$(DESTDIR)/usr
+# CONFDIR=/usr/local/lib/mandos
 CONFDIR=$(DESTDIR)/etc/mandos
-KEYDIR=$(DESTDIR)/etc/keys/mandos
-MANDIR=$(PREFIX)/share/man
-INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
-##
+# MANDIR=/usr/local/man
+MANDIR=$(DESTDIR)/usr/share/man
 
 GNUTLS_CFLAGS=$(shell libgnutls-config --cflags)
 GNUTLS_LIBS=$(shell libgnutls-config --libs)
@@ -42,7 +32,7 @@
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS)
 LDFLAGS=$(COVERAGE)
 
-# Commands to format a DocBook <refentry> document into a manual page
+# Commands to format a DocBook refentry document into a manual page
 DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
 	--param man.charmap.use.subset		0 \
 	--param make.year.ranges		1 \
@@ -52,13 +42,13 @@
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
 	$(MANPOST) $(notdir $@)
-# DocBook-to-man post-processing to fix a '\n' escape bug
+# DocBook-to-man post-processing to fix a \n escape bug
 MANPOST=sed --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
-PLUGINS=plugins.d/password-prompt plugins.d/mandos-client
+PLUGINS=plugins.d/password-prompt plugins.d/password-request
 PROGS=plugin-runner $(PLUGINS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
-	plugins.d/mandos-client.8mandos \
+	plugins.d/password-request.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
 	mandos-clients.conf.5
 
@@ -89,12 +79,12 @@
 plugin-runner.8mandos: plugin-runner.xml overview.xml legalnotice.xml
 	$(DOCBOOKTOMAN)
 
-plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
+plugins.d/password-request.8mandos: plugins.d/password-request.xml \
 					mandos-options.xml \
 					overview.xml legalnotice.xml
 	$(DOCBOOKTOMAN)
 
-plugins.d/mandos-client: plugins.d/mandos-client.o
+plugins.d/password-request: plugins.d/password-request.o
 	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
 		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
@@ -114,12 +104,17 @@
 	./mandos --check
 
 # Run the client with a local config and key
-run-client: all keydir/seckey.txt keydir/pubkey.txt
+run-client: all keydir/seckey.txt keydir/pubkey.txt \
+	keydir/secring.gpg keydir/pubring.gpg
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt
+		--options-for=password-request:--keydir=keydir
 
 # Used by run-client
+keydir/secring.gpg: keydir/seckey.txt
+	gpg --homedir $(dir $<) --import $^
+keydir/pubring.gpg: keydir/pubkey.txt
+	gpg --homedir $(dir $<) --import $^
 keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
 	install --directory keydir
 	./mandos-keygen --dir keydir --force
@@ -131,27 +126,22 @@
 # Used by run-server
 confdir/mandos.conf: mandos.conf
 	install --directory confdir
-	install --mode=u=rw,go=r $^ $@
+	install $^ $@
 confdir/clients.conf: clients.conf keydir/seckey.txt
 	install --directory confdir
-	install --mode=u=rw $< $@
+	install clients.conf $@
 # Add a client password
 	./mandos-keygen --dir keydir --password >> $@
 
-install: install-server install-client-nokey
+install: install-server install-client
 
 install-server: doc
-	install --directory $(CONFDIR)
-	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
-	install --mode=u=rw,go=r --target-directory=$(CONFDIR) \
-		mandos.conf
-	install --mode=u=rw --target-directory=$(CONFDIR) \
+	install --directory --parents $(CONFDIR) $(MANDIR)/man5 \
+		$(MANDIR)/man8
+	install --mode=0755 mandos $(PREFIX)/sbin/mandos
+	install --mode=0644 --target-directory=$(CONFDIR) mandos.conf
+	install --mode=0640 --target-directory=$(CONFDIR) \
 		clients.conf
-	install --mode=u=rwx,go=rx init.d-mandos \
-		$(DESTDIR)/etc/init.d/mandos
-	install --mode=u=rw,go=r default-mandos \
-		$(DESTDIR)/etc/default/mandos
-	update-rc.d mandos defaults
 	gzip --best --to-stdout mandos.8 \
 		> $(MANDIR)/man8/mandos.8.gz
 	gzip --best --to-stdout mandos.conf.5 \
@@ -159,96 +149,72 @@
 	gzip --best --to-stdout mandos-clients.conf.5 \
 		> $(MANDIR)/man5/mandos-clients.conf.5.gz
 
-install-client-nokey: all doc
-	install --directory $(PREFIX)/lib/mandos $(CONFDIR)
-	install --directory --mode=u=rwx $(KEYDIR) \
-		$(PREFIX)/lib/mandos/plugins.d
-	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
-		install --mode=u=rwx \
-			--directory "$(CONFDIR)/plugins.d" && \
-		install --mode=u=rw,go=r etc-plugins.d-README \
-			$(CONFDIR)/plugins.d/README ; \
-	fi
-	install --mode=u=rwx,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos plugin-runner
-	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
+install-client: all doc /usr/share/initramfs-tools/hooks/.
+	install --directory --parents $(PREFIX)/lib/mandos \
+		$(CONFDIR) $(MANDIR)/man8
+	install --directory --mode=0700 $(PREFIX)/lib/mandos/plugins.d
+	chmod u=rwx,g=,o= $(PREFIX)/lib/mandos/plugins.d
+	install --mode=0755 --target-directory=$(PREFIX)/lib/mandos \
+		plugin-runner
+	install --mode=0755 --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
-	install --mode=u=rwx,go=rx \
+	install --mode=0755 \
 		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/password-prompt
-	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
-		plugins.d/mandos-client
-	install --mode=u=rwx,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
-		plugins.d/usplash
+	install --mode=4755 \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		plugins.d/password-request
 	install initramfs-tools-hook \
-		$(INITRAMFSTOOLS)/hooks/mandos
-	install --mode=u=rw,go=r initramfs-tools-hook-conf \
-		$(INITRAMFSTOOLS)/conf-hooks.d/mandos
+		/usr/share/initramfs-tools/hooks/mandos
+	install initramfs-tools-hook-conf \
+		/usr/share/initramfs-tools/conf-hooks.d/mandos
 	install initramfs-tools-script \
-		$(INITRAMFSTOOLS)/scripts/local-top/mandos
-	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
+		/usr/share/initramfs-tools/scripts/local-top/mandos
 	gzip --best --to-stdout mandos-keygen.8 \
 		> $(MANDIR)/man8/mandos-keygen.8.gz
 	gzip --best --to-stdout plugin-runner.8mandos \
 		> $(MANDIR)/man8/plugin-runner.8mandos.gz
 	gzip --best --to-stdout plugins.d/password-prompt.8mandos \
 		> $(MANDIR)/man8/password-prompt.8mandos.gz
-	gzip --best --to-stdout plugins.d/mandos-client.8mandos \
-		> $(MANDIR)/man8/mandos-client.8mandos.gz
-
-install-client: install-client-nokey
-# Post-installation stuff
-	-$(PREFIX)/sbin/mandos-keygen --dir "$(KEYDIR)"
+	gzip --best --to-stdout plugins.d/password-request.8mandos \
+		> $(MANDIR)/man8/password-request.8mandos.gz
+	-$(PREFIX)/sbin/mandos-keygen
 	update-initramfs -k all -u
-	echo "Now run mandos-keygen --password --dir $(KEYDIR)"
 
 uninstall: uninstall-server uninstall-client
 
-uninstall-server:
+uninstall-server: $(PREFIX)/sbin/mandos
 	-rm --force $(PREFIX)/sbin/mandos \
 		$(MANDIR)/man8/mandos.8.gz \
 		$(MANDIR)/man5/mandos.conf.5.gz \
 		$(MANDIR)/man5/mandos-clients.conf.5.gz
-	update-rc.d -f mandos remove
 	-rmdir $(CONFDIR)
 
 uninstall-client:
 # Refuse to uninstall client if /etc/crypttab is explicitly configured
 # to use it.
 	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
-		$(DESTDIR)/etc/crypttab
+		/etc/crypttab
 	-rm --force $(PREFIX)/sbin/mandos-keygen \
 		$(PREFIX)/lib/mandos/plugin-runner \
 		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
-		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
-		$(PREFIX)/lib/mandos/plugins.d/usplash \
-		$(INITRAMFSTOOLS)/hooks/mandos \
-		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
-		$(INITRAMFSTOOLS)/scripts/local-top/mandos \
+		$(PREFIX)/lib/mandos/plugins.d/password-request \
+		/usr/share/initramfs-tools/hooks/mandos \
+		/usr/share/initramfs-tools/conf-hooks.d/mandos \
 		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
 		$(MANDIR)/man8/password-prompt.8mandos.gz \
-		$(MANDIR)/man8/mandos-client.8mandos.gz
-	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
-		rm --force $(CONFDIR)/plugins.d/README; \
-	fi
+		$(MANDIR)/man8/password-request.8mandos.gz
 	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
+		 $(PREFIX)/lib/mandos $(CONFDIR)
 	update-initramfs -k all -u
 
 purge: purge-server purge-client
 
 purge-server: uninstall-server
-	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
-		$(DESTDIR)/etc/default/mandos \
-		$(DESTDIR)/etc/init.d/mandos \
-		$(DESTDIR)/var/run/mandos.pid
+	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf
 	-rmdir $(CONFDIR)
 
 purge-client: uninstall-client
-	-shred --remove $(KEYDIR)/seckey.txt
-	-rm --force $(CONFDIR)/plugin-runner.conf \
-		$(KEYDIR)/pubkey.txt $(KEYDIR)/seckey.txt
-	-rmdir $(KEYDIR) $(CONFDIR)/plugins.d $(CONFDIR)
+	-rm --force $(CONFDIR)/seckey.txt $(CONFDIR)/pubkey.txt
+	-rmdir $(CONFDIR) $(CONFDIR)/plugins.d

=== removed file 'README'
--- README	2008-09-17 00:34:09 +0000
+++ README	1970-01-01 00:00:00 +0000
@@ -1,152 +0,0 @@
--*- org -*-
-
-* Mandos
-  - Have your cake and eat it too!
-  
-  You know how it is.  You’ve heard of it happening.  The Man comes
-  and takes away your servers, your friends’ servers, the servers of
-  everybody in the same hosting facility. The servers of their
-  neighbors, and their neighbors’ friends.  The servers of people who
-  owe them money.  And like *that*, they’re gone.  And you doubt
-  you’ll ever see them again.
-  
-  That is why your servers have encrypted root file systems.  However,
-  there’s a downside.  There’s no going around it: rebooting is a
-  pain.  Dragging out that rarely-used keyboard and screen and
-  unraveling cables behind your servers to plug them in to type in
-  that password is messy, especially if you have many servers.  There
-  are some people who do clever things like using serial line consoles
-  and daisy-chain it to the next server, and keep all the servers
-  connected in a ring with serial cables, which will work, if your
-  servers are physically close enough.  There are also other
-  out-of-band management solutions, but with *all* these, you still
-  have to be on hand and manually type in the password at boot time.
-  Otherwise the server just sits there, waiting for a password.
-  
-  Wouldn’t it be great if you could have the security of encrypted
-  root file systems and still have servers that could boot up
-  automatically if there was a short power outage while you were
-  asleep?  That you could reboot at will, without having someone run
-  over to the server to type in the password?
-  
-  Well, with Mandos, you (almost) can!  The gain in convenience will
-  only be offset by a small loss in security.  The setup is as
-  follows:
-  
-  The server will still have its encrypted root file system.  The
-  password to this file system will be stored on another computer
-  (henceforth known as the Mandos server) on the same local network.
-  The password will *not* be stored in plaintext, but encrypted with
-  OpenPGP.  To decrypt this password, a key is needed.  This key (the
-  Mandos client key) will not be stored there, but back on the
-  original server (henceforth known as the Mandos client) in the
-  initial RAM disk image.  Oh, and all network Mandos client/server
-  communications will be encrypted, using TLS (SSL).
-  
-  So, at boot time, the Mandos client will ask for its encrypted data
-  over the network, decrypt it to get the password, use it to decrypt
-  the root file, and continue booting.
-  
-  Now, of course the initial RAM disk image is not on the encrypted
-  root file system, so anyone who had physical access could take the
-  Mandos client computer offline and read the disk with their own
-  tools to get the authentication keys used by a client.  *But*, by
-  then the Mandos server should notice that the original server has
-  been offline for too long, and will no longer give out the encrypted
-  key.  The timing here is the only real weak point, and the method,
-  frequency and timeout of the server’s checking can be adjusted to
-  any desired level of paranoia
-  
-  (The encrypted keys on the Mandos server is on its normal file
-  system, so those are safe, provided the root file system of *that*
-  server is encrypted.)
-
-* FAQ - couldn’t the security be defeated by...
-
-** Grabbing the Mandos client key from the initrd *really quickly*?
-   This, as mentioned above, is the only real weak point.  But if you
-   set the timing values tight enough, this will be really difficult
-   to do.  An attacker would have to physically disassemble the client
-   computer, extract the key from the initial RAM disk image, and then
-   connect to a *still online* Mandos server to get the encrypted key,
-   and do all this *before* the Mandos server timeout kicks in and the
-   Mandos server refuses to give out the key to anyone.
-   
-   Now, as the typical procedure seems to be to barge in and turn off
-   and grab *all* computers, to maybe look at them months later, this
-   is not likely.  If someone does that, the whole system *will* lock
-   itself up completely, since Mandos servers are no longer running.
-   
-   For sophisticated attackers who *could* do the clever thing, *and*
-   had physical access to the server for enough time, it would be
-   simpler to get a key for an encrypted file system by using hardware
-   memory scanners and reading it right off the memory bus.
-
-** Replay attacks?
-   Nope, the network stuff is all done over TLS, which provides
-   protection against that.
-
-** Man-in-the-middle?
-   No.  The server only gives out the passwords to clients which have
-   *in the TLS handshake* proven that they do indeed hold the OpenPGP
-   private key corresponding to that client.
-
-** Physically grabbing the Mandos server computer?
-   You could protect *that* computer the old-fashioned way, with a
-   must-type-in-the-password-at-boot method.  Or you could have two
-   computers be the Mandos server for each other.
-   
-   Multiple Mandos servers can coexist on a network without any
-   trouble.  They do not clash, and clients will try all available
-   servers.  This means that if just one reboots then the other can
-   bring it back up, but if both reboots at the same time they will
-   stay down until someone types in the password on one of them.
-
-** Faking ping replies?
-   The default for the server is to use "fping", the replies to which
-   could be faked to eliminate the timeout.  But this could easily be
-   changed to any shell command, with any security measures you like.
-   It could, for instance, be changed to an SSH command with strict
-   keychecking, which could not be faked.  Or IPsec could be used for
-   the ping packets, making them secure.
-
-* Security Summary
-  So, in summary:  The only weakness in the Mandos system is from
-  people who have:
-  1. The power to come in and physically take your servers, *and*
-  2. The cunning and patience to do it carefully, one at a time, and
-     *quickly*, faking Mandos client/server responses for each one
-     before the timeout.
-  
-  While there are some who may be threatened by people who have *both*
-  these attributes, they do not, probably, constitute the majority.
-  
-  If you *do* face such opponents, you must figure that they could
-  just as well open your servers and read the file system keys right
-  off the memory by running wires to the memory bus.
-  
-  What Mandos is designed to protect against is *not* such determined,
-  focused, and competent attacks, but against the early morning knock
-  on your door and the sudden absence of all the servers in your
-  server room.  Which it does nicely.
-
-* Copyright
-
-    Copyright © 2008 Teddy Hogeborn
-                2008 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.

=== modified file 'TODO'
--- TODO	2008-09-19 00:00:51 +0000
+++ TODO	2008-09-03 05:04:40 +0000
@@ -1,82 +1,102 @@
 -*- org -*-
 
+* [#A] README file
+
 * plugin-runner
-** TODO Man page  for plugin-runner.conf.5
-   link to plugin-runner.8
+** [#B] Add more comments to code
+** [#B] Add more if(debug) calls
+** [#B] Seperate more code to function for more readability
 
-* mandos-client
-** TODO [#B] Temporarily lower kernel log level
+* password-request
+** [#A] Man page: man8/password-request.8mandos
+*** FILES
+    Describe the key files and the key ring files.  Also note that
+    they should normally have been automatically created.
+*** BUGS
+*** EXAMPLE
+    Examples of normal usage, debug usage, debugging by connecting
+    directly, etc.
+*** SECURITY
+*** SEE ALSO
+    Update from mandos.xml
+** [#B] Temporarily lower kernel log level
    for less printouts during sucessfull boot.
-** TODO [#C] IPv4 support
+** IPv4 support
+** use strsep instead of strtok?
+** Do not depend on GnuPG key rings on disk
+   This would mean creating new GnuPG key rings with GPGME by
+   importing the key files from scratch on every program start.
+** Keydir move: /etc/mandos -> /etc/keys/mandos
+   Must create in preinst if not pre-depending on cryptsetup
 
-* DONE password-prompt
+* password-prompt
+** [#C] Use getpass(3)?
+   Man page says "obsolete", but [[info:libc:getpass][GNU LibC Manual: Reading Passwords]]
+   does not.  See also [[http://sources.redhat.com/ml/libc-alpha/2003-05/msg00251.html][Marcus Brinkmann: Re: getpass obsolete?]] and
+   [[http://article.gmane.org/gmane.comp.lib.glibc.alpha/4906][Petter Reinholdtsen: Re: getpass obsolete?]], and especially also
+   [[http://www.steve.org.uk/Reference/Unix/faq_4.html#SEC48][Unix Programming FAQ 3.1 How can I make my program not echo input?]]
 
 * mandos (server)
-** TODO [#B] Log level				:bugs:
-** TODO /etc/mandos/clients.d/*.conf
+** [#A] /etc/init.d/mandos-server		:teddy:
+** [#B] Log level				:bugs:
+** /etc/mandos/clients.d/*.conf
    Watch this directory and add/remove/update clients?
-** TODO config for TXT record
-** TODO [#B] Run-time communication with server :bugs:
+** config for TXT record
+** [#B] Run-time communication with server	:bugs:
    Probably using D-Bus
    See also [[*Mandos-tools]]
-** TODO Implement --foreground			:bugs:
-   [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Implement --socket
-   [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages	:bugs:
+** Implement --foreground			:bugs:
+   [[info:standards:Option%20Table][Table of Long Options]]
+** Implement --socket
+   [[info:standards:Option%20Table][Table of Long Options]]
+** Date+time on console log messages		:bugs:
    Is this the default?
-** TODO delete hook when clients fall out by timeout
 
 * Mandos-tools/utilities
   All of this probably using D-Bus
-** TODO List clients
-** TODO Disable client
-** TODO Enable client
-** TODO Reset timer
+** List clients
+** Disable client
+** Enable client
 
 * Man pages
-** TODO Use xinclude for all common sections
+** Use xinclude for common sections
    Like authors, etc.
 
 
 * Installer
 ** Client-side
-*** TODO Update initrd.img after installation
+*** Update initrd.img after installation
     This seems to use some kind of "trigger" system
     [[file:/usr/share/doc/dpkg/triggers.txt.gz]]
     dpkg-trigger(1), deb-triggers(5)
+*** Keydir move: /etc/mandos -> /etc/keys/mandos
+    Must create in preinst if not pre-depending on cryptsetup
 *** mandos-keygen
-**** TODO [#A] Ask for password twice for confirmation
-**** TODO "--passfile" option
+**** "--passfile" option
      Using the "secfile" option instead of "secret"
-**** TODO [#B] "--test" option
+**** [#A] "--test" option
      For testing decryption before rebooting.
 ** Server-side
-*** TODO [#A] Create mandos user and group for server
-
+*** [#A] Create mandos user and group for server
+*** [#A] Create /var/run/mandos directory with perm and ownership
 
 * [#A] Package
 ** /usr/share/initramfs-tools/hooks/mandos
-*** TODO Do not install in initrd.img if configured not to.
+*** Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/conf.d/mandos"?  Definitely a debconf
     question.
-** TODO /etc/bash_completion.d/mandos
+** /etc/bash_completion.d/mandos
    From XML sources directly?
-** TODO unperish
-** DONE bzr-builddeb
-** TODO mandos user/group creation
-** TODO Key creation in postinst
-
-* TODO Web site
-** DONE http://www.fukt.bsnet.se/mandos
-   Redirects to the wiki page
-** TODO http://wiki.fukt.bsnet.se/wiki/Mandos
+** unperish
+** bzr-builddeb
+
+* INSTALL file
+
+* Web site
 
 * Mailing list
-** DONE mandos-dev
-*** TODO http://gmane.org/subscribe.php
 
-* TODO Announce project on Usenet
+* Announce project on news
   [[news:comp.os.linux.announce]]
 
 

=== removed directory 'debian'
=== removed file 'debian/changelog'
--- debian/changelog	2008-09-17 00:34:09 +0000
+++ debian/changelog	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-mandos (1.0) unstable; urgency=low
-
-  * Initial Release.
-
- -- Mandos Maintainers <mandos@fukt.bsnet.se>  Sun, 07 Sep 2008 11:55:51 +0200

=== removed file 'debian/compat'
--- debian/compat	2008-09-17 00:34:09 +0000
+++ debian/compat	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-7

=== removed file 'debian/control'
--- debian/control	2008-09-17 00:34:09 +0000
+++ debian/control	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-Source: mandos
-Section: admin
-Priority: extra
-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Build-Depends: debhelper (>= 7), docbook-xsl, docbook (<5.0),
-	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc
-Standards-Version: 3.8.0
-Vcs-Bzr: ftp://anonymous@ftp.fukt.bsnet.se/pub/mandos/latest
-Homepage: http://www.fukt.bsnet.se/mandos
-
-Package: mandos
-Architecture: all
-Depends: ${shlibs:Depends}, ${misc:Depends}, python (>=2.5),
-	python-gnutls, python-dbus, python-avahi, avahi-daemon,
-	gnupg (< 2)
-Recommends: fping
-Description: a server giving encrypted passwords to Mandos clients
- This is the server part of the Mandos system, which allows
- computers to have encrypted root file systems and at the
- same time be capable of remote and/or unattended reboots.
- .
- The computers run a small client program in the initial RAM
- disk environment which will communicate with a server over a
- network.  All network communication is encrypted using TLS.
- The clients are identified by the server using an OpenPGP
- key; each client has one unique to it.  The server sends the
- clients an encrypted password.  The encrypted password is
- decrypted by the clients using the same OpenPGP key, and the
- password is then used to unlock the root file system,
- whereupon the computers can continue booting normally.
-
-Package: mandos-client
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Enhances: cryptsetup
-Description: do unattended reboots with an encrypted root file system
- This is the client part of the Mandos system, which allows
- computers to have encrypted root file systems and at the
- same time be capable of remote and/or unattended reboots.
- .
- The computers run a small client program in the initial RAM
- disk environment which will communicate with a server over a
- network.  All network communication is encrypted using TLS.
- The clients are identified by the server using an OpenPGP
- key; each client has one unique to it.  The server sends the
- clients an encrypted password.  The encrypted password is
- decrypted by the clients using the same OpenPGP key, and the
- password is then used to unlock the root file system,
- whereupon the computers can continue booting normally.

=== removed file 'debian/copyright'
--- debian/copyright	2008-09-17 00:34:09 +0000
+++ debian/copyright	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-Authors: Teddy Hogeborn, Björn Påhlsson
-
-Homepage: <http://www.fukt.bsnet.se/mandos>
-
-Copyright:
-
-    Copyright © 2008 Teddy Hogeborn
-                2008 Björn Påhlsson
-
-License:
-
-    This program is free software: you can redistribute it and/or
-    modify it under the terms of the GNU General Public License as
-    published by the Free Software Foundation, either version 3 of the
-    License, or (at your option) any later version.
-
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-    General Public License for more details.
-
-    You should have received a copy of the GNU General Public License
-    along with this program.  If not, see
-    <http://www.gnu.org/licenses/>.
-
-On Debian systems, the complete text of the GNU General Public License
-can be found in "/usr/share/common-licenses/GPL".

=== removed file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2008-09-19 00:00:51 +0000
+++ debian/mandos-client.README.Debian	1970-01-01 00:00:00 +0000
@@ -1,15 +0,0 @@
-A client key has been automatically created in /etc/keys/mandos.  The
-next step is to run "mandos-keygen --password" to get a config file
-stanza to copy and paste into /etc/mandos/clients.conf on the Mandos
-server.
-
-Also, if some other network interface than "eth0" is used, it will be
-necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-change the line there.  If this file is changed, it will be necessary
-to update the initrd image by doing "update-initramfs -k all -u".
-
-It is NOT necessary to edit /etc/crypttab to specify
-/usr/lib/mandos/plugin-runner as a keyscript for the root file system;
-if no keyscript is given for the root file system, the Mandos client
-will be the new default way for getting a password for the root file
-system when booting.

=== removed file 'debian/mandos-client.dirs'
--- debian/mandos-client.dirs	2008-09-17 00:34:09 +0000
+++ debian/mandos-client.dirs	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-usr/share/man/man8
-usr/sbin
-usr/share/initramfs-tools/hooks
-usr/share/initramfs-tools/conf-hooks.d
-usr/share/initramfs-tools/scripts/local-top

=== removed file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2008-09-17 00:34:09 +0000
+++ debian/mandos-client.lintian-overrides	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
-mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz 297: warning [p 4, 5.8i]: can't break line
-mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
-mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755

=== removed file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2008-09-17 00:34:09 +0000
+++ debian/mandos-client.postinst	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-#!/bin/bash -e
-# This script can be called in the following ways:
-#
-# After the package was installed:
-#       <postinst> configure <old-version>
-#
-#
-# If prerm fails during upgrade or fails on failed upgrade:
-#       <old-postinst> abort-upgrade <new-version>
-#
-# If prerm fails during deconfiguration of a package:
-#       <postinst> abort-deconfigure in-favour <new-package> <version>
-#                  removing <old-package> <version>
-#
-# If prerm fails during replacement due to conflict:
-#       <postinst> abort-remove in-favour <new-package> <version>
-
-. /usr/share/debconf/confmodule
-
-# Update the initramfs
-update_initramfs()
-{
-	if which update-initramfs >/dev/null 2>&1; then
-		update-initramfs -u
-	fi
-}
-
-case "$1" in
-    configure)
-	update_initramfs
-	;;
-
-    abort-upgrade|abort-deconfigure|abort-remove)
-	;;
-
-    *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
-	exit 1
-	;;
-esac
-
-#DEBHELPER#
-
-exit 0

=== removed file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2008-09-19 00:00:51 +0000
+++ debian/mandos-client.postrm	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-#!/bin/sh -e
-# This script can be called in the following ways:
-#
-# After the package was removed:
-#       <postrm> remove
-#
-# After the package was purged:
-#       <postrm> purge
-#
-# After the package was upgraded:
-#       <old-postrm> upgrade <new-version>
-# if that fails:
-#       <new-postrm> failed-upgrade <old-version>
-#
-#
-# After all of the packages files have been replaced:
-#       <postrm> disappear <overwriting-package> <version>
-#
-#
-# If preinst fails during install:
-#       <new-postrm> abort-install
-#
-# If preinst fails during upgrade of removed package:
-#       <new-postrm> abort-install <old-version>
-#
-# If preinst fails during upgrade:
-#       <new-postrm> abort-upgrade <old-version>
-
-
-# Update the initramfs
-update_initramfs()
-{
-	if type update-initramfs >/dev/null 2>&1 ; then
-		update-initramfs -u -k all
-	fi
-}
-
-
-case "$1" in
-    remove)
-	update_initramfs
-	;;
-
-    purge)
-	shred --remove /etc/keys/mandos/seckey.txt || :
-	rm --force /etc/mandos/plugin-runner.conf \
-	    /etc/keys/mandos/pubkey.txt \
-	    /etc/keys/mandos/seckey.txt
-	rmdir /etc/keys/mandos /etc/mandos/plugins.d /etc/mandos || :
-	;;
-    upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
-	;;
-
-    *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
-	exit 1
-	;;
-esac
-
-#DEBHELPER#
-
-exit 0

=== removed file 'debian/mandos.dirs'
--- debian/mandos.dirs	2008-09-17 00:34:09 +0000
+++ debian/mandos.dirs	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-usr/share/man/man5
-usr/share/man/man8
-etc/init.d
-etc/default
-usr/sbin

=== removed file 'debian/mandos.lintian-overrides'
--- debian/mandos.lintian-overrides	2008-09-17 00:34:09 +0000
+++ debian/mandos.lintian-overrides	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-mandos binary: non-standard-file-perm etc/mandos/clients.conf 0600 != 0644

=== removed file 'debian/mandos.postinst'
--- debian/mandos.postinst	2008-09-19 00:54:24 +0000
+++ debian/mandos.postinst	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-#!/bin/bash -e
-# This script can be called in the following ways:
-#
-# After the package was installed:
-#       <postinst> configure <old-version>
-#
-#
-# If prerm fails during upgrade or fails on failed upgrade:
-#       <old-postinst> abort-upgrade <new-version>
-#
-# If prerm fails during deconfiguration of a package:
-#       <postinst> abort-deconfigure in-favour <new-package> <version>
-#                  removing <old-package> <version>
-#
-# If prerm fails during replacement due to conflict:
-#       <postinst> abort-remove in-favour <new-package> <version>
-
-. /usr/share/debconf/confmodule
-
-case "$1" in
-    configure)
-	if ! getent passwd mandos >/dev/null; then
-	    adduser --disabled-password  --quiet --system \
-		--home /var/run/mandos --no-create-home \
-		--gecos "Mandos password daemon" --group mandos
-	fi
-	;;
-
-    abort-upgrade|abort-deconfigure|abort-remove)
-	;;
-
-    *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
-	exit 1
-	;;
-esac
-
-#DEBHELPER#
-
-exit 0

=== removed file 'debian/mandos.postrm'
--- debian/mandos.postrm	2008-09-19 00:54:24 +0000
+++ debian/mandos.postrm	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#DEBHELPER#
-
-if [ "$1" = "purge" ] ; then
-        deluser --quiet --system mandos > /dev/null || true
-        delgroup --quiet --system mandos > /dev/null || true
-fi
-

=== removed file 'debian/rules'
--- debian/rules	2008-09-17 00:34:09 +0000
+++ debian/rules	1970-01-01 00:00:00 +0000
@@ -1,116 +0,0 @@
-#!/usr/bin/make -f
-# Sample debian/rules that uses debhelper.
-#
-# This file was originally written by Joey Hess and Craig Small.
-# As a special exception, when this file is copied by dh-make into a
-# dh-make output file, you may use that output file without restriction.
-# This special exception was added by Craig Small in version 0.37 of dh-make.
-#
-# Modified to make a template file for a multi-binary package with separated
-# build-arch and build-indep targets  by Bill Allombert 2001
-
-# Uncomment this to turn on verbose mode.
-export DH_VERBOSE=1
-
-# This has to be exported to make some magic below work.
-export DH_OPTIONS
-
-configure: configure-stamp
-configure-stamp:
-	dh_testdir
-# Add here commands to configure the package.
-	touch configure-stamp
-
-#Architecture
-build: build-arch build-indep
-
-build-arch: build-arch-stamp
-build-arch-stamp: configure-stamp
-# Add here commands to compile the arch part of the package.
-	dh_auto_build -- all doc
-	touch $@
-
-build-indep: build-indep-stamp
-build-indep-stamp: configure-stamp
-# Add here commands to compile the indep part of the package.
-	dh_auto_build -- doc
-	touch $@
-
-clean:
-	dh_testdir
-	dh_testroot
-	rm -f build-arch-stamp build-indep-stamp configure-stamp
-# Add here commands to clean up after the build process.
-	dh_auto_clean
-	dh_clean
-
-install: install-indep install-arch
-install-indep:
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs --indep
-# Add here commands to install the indep part of the package into
-# debian/<package>-doc.
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
-	dh_lintian
-	dh_installinit --onlyscripts --no-start
-	dh_install --indep
-
-install-arch:
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs --same-arch
-
-# Add here commands to install the arch part of the package into
-# debian/tmp.
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
-	dh_lintian
-	dh_install --same-arch
-
-# Must not depend on anything. This is to be called by
-# binary-arch/binary-indep
-# in another 'make' thread.
-binary-common:
-	dh_testdir
-	dh_testroot
-	dh_installchangelogs
-	dh_installdocs
-#	dh_installexamples
-#	dh_installmenu
-#	dh_installdebconf
-#	dh_installlogrotate
-#	dh_installemacsen
-#	dh_installpam
-#	dh_installmime
-#	dh_pycentral
-#	dh_installinit
-#	dh_installcron
-#	dh_installinfo
-#	dh_installman
-	dh_link
-	dh_strip
-	dh_compress
-	dh_fixperms --exclude etc/keys/mandos \
-		--exclude etc/mandos/clients.conf \
-		--exclude usr/lib/mandos/plugins.d
-#	dh_perl
-	dh_makeshlibs
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-# Build architecture independant packages using the common target.
-binary-indep: build-indep install-indep
-	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common
-
-# Build architecture dependant packages using the common target.
-binary-arch: build-arch install-arch
-	$(MAKE) -f debian/rules DH_OPTIONS=--same-arch binary-common
-
-binary: binary-arch binary-indep
-
-.PHONY: build clean binary-indep binary-arch binary install \
-		install-indep install-arch configure

=== removed file 'default-mandos'
--- default-mandos	2008-09-17 00:34:09 +0000
+++ default-mandos	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-# Directory where configuration files are located.  Default is
-# "/etc/mandos".
-# 
-#CONFIGDIR=/etc/mandos
-
-# Additional options that are passed to the Daemon.
-DAEMON_ARGS=""

=== removed file 'etc-plugins.d-README'
--- etc-plugins.d-README	2008-09-06 16:11:50 +0000
+++ etc-plugins.d-README	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-Any plugins found here in /etc/mandos/plugins.d will override and add
-to the normal Mandos plugins.  When adding or changing plugins, do not
-forget to update the initital RAM disk image:
-
-# update-initramfs -k all -u

=== removed file 'init.d-mandos'
--- init.d-mandos	2008-09-05 16:24:33 +0000
+++ init.d-mandos	1970-01-01 00:00:00 +0000
@@ -1,159 +0,0 @@
-#! /bin/sh
-### BEGIN INIT INFO
-# Provides:          mandos
-# Required-Start:    $remote_fs
-# Required-Stop:     $remote_fs
-# Default-Start:     2 3 4 5
-# Default-Stop:      0 1 6
-# Short-Description: Mandos server
-# Description:       Gives encrypted passwords to Mandos clients
-### END INIT INFO
-
-# Author: Teddy Hogeborn <teddy@fukt.bsnet.se>
-# Author: Björn Påhlsson <belorn@fukt.bsnet.se>
-#
-# Please remove the "Author" lines above and replace them
-# with your own name if you copy and modify this script.
-
-# Do NOT "set -e"
-
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
-PATH=/sbin:/usr/sbin:/bin:/usr/bin
-DESC="Mandos root file system password server"
-NAME=mandos
-DAEMON=/usr/sbin/$NAME
-DAEMON_ARGS=""
-PIDFILE=/var/run/$NAME.pid
-SCRIPTNAME=/etc/init.d/$NAME
-
-# Exit if the package is not installed
-[ -x "$DAEMON" ] || exit 0
-
-# Read configuration variable file if it is present
-[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-
-if [ -n "$CONFIGDIR" ]; then
-   DAEMON_ARGS="$DAEMON_ARGS --configdir $CONFIGDIR"
-fi
-
-# Load the VERBOSE setting and other rcS variables
-. /lib/init/vars.sh
-
-# Define LSB log_* functions.
-# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
-. /lib/lsb/init-functions
-
-#
-# Function that starts the daemon/service
-#
-do_start()
-{
-	# Return
-	#   0 if daemon has been started
-	#   1 if daemon was already running
-	#   2 if daemon could not be started
-	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
-		|| return 1
-	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
-		$DAEMON_ARGS \
-		|| return 2
-	# Add code here, if necessary, that waits for the process to be ready
-	# to handle requests from services started subsequently which depend
-	# on this one.  As a last resort, sleep for some time.
-}
-
-#
-# Function that stops the daemon/service
-#
-do_stop()
-{
-	# Return
-	#   0 if daemon has been stopped
-	#   1 if daemon was already stopped
-	#   2 if daemon could not be stopped
-	#   other if a failure occurred
-	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
-	RETVAL="$?"
-	[ "$RETVAL" = 2 ] && return 2
-	# Wait for children to finish too if this is a daemon that forks
-	# and if the daemon is only ever run from this initscript.
-	# If the above conditions are not satisfied then add some other code
-	# that waits for the process to drop all resources that could be
-	# needed by services started subsequently.  A last resort is to
-	# sleep for some time.
-	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
-	[ "$?" = 2 ] && return 2
-	# Many daemons don't delete their pidfiles when they exit.
-	rm -f $PIDFILE
-	return "$RETVAL"
-}
-
-#
-# Function that sends a SIGHUP to the daemon/service
-#
-do_reload() {
-	#
-	# If the daemon can reload its configuration without
-	# restarting (for example, when it is sent a SIGHUP),
-	# then implement that here.
-	#
-	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
-	return 0
-}
-
-case "$1" in
-  start)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
-	do_start
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  stop)
-	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
-	do_stop
-	case "$?" in
-		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-	esac
-	;;
-  #reload|force-reload)
-	#
-	# If do_reload() is not implemented then leave this commented out
-	# and leave 'force-reload' as an alias for 'restart'.
-	#
-	#log_daemon_msg "Reloading $DESC" "$NAME"
-	#do_reload
-	#log_end_msg $?
-	#;;
-  restart|force-reload)
-	#
-	# If the "reload" option is implemented then remove the
-	# 'force-reload' alias
-	#
-	log_daemon_msg "Restarting $DESC" "$NAME"
-	do_stop
-	case "$?" in
-	  0|1)
-		do_start
-		case "$?" in
-			0) log_end_msg 0 ;;
-			1) log_end_msg 1 ;; # Old process is still running
-			*) log_end_msg 1 ;; # Failed to start
-		esac
-		;;
-	  *)
-	  	# Failed to stop
-		log_end_msg 1
-		;;
-	esac
-	;;
-  *)
-	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
-	exit 3
-	;;
-esac
-
-:

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2008-09-19 00:54:24 +0000
+++ initramfs-tools-hook	2008-08-24 23:18:18 +0000
@@ -29,37 +29,15 @@
 
 . /usr/share/initramfs-tools/hook-functions
 
-for d in /usr /usr/local; do
-    if [ -d "$d"/lib/mandos ]; then
-	prefix="$d"
-	break
-    fi
-done
-if [ -z "$prefix" ]; then
+if [ -d /usr/lib/mandos ]; then
+    prefix=/usr
+elif [ -d /usr/local/lib/mandos ]; then
+    prefix=/usr/local
+else
     # Mandos not found
     exit 1
 fi
 
-for d in /etc/keys/mandos /etc/mandos/keys; do
-    if [ -d "$d" ]; then
-	keydir="$d"
-	break
-    fi
-done
-if [ -z "$keydir" ]; then
-    # Mandos key directory not found
-    exit 1
-fi
-
-mandos_user="`{ getent passwd mandos \
-		|| getent passwd nobody \
-		|| echo ::65534::::; } \
-	| awk --field-separator=: '{ print $3 }'`" 
-mandos_group="`{ getent group mandos \
-		|| getent group nogroup \
-		|| echo ::65534:; } \
-	| awk --field-separator=: '{ print $3 }'`"
-
 # The Mandos network client uses the network
 auto_add_modules net
 # The Mandos network client uses IPv6
@@ -71,13 +49,11 @@
 PLUGINDIR="${MANDOSDIR}/plugins.d"
 
 # Make directories
-install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}"
-install --owner=${mandos_user} --group=${mandos_group} --directory \
-    --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
+mkdir --parents "${DESTDIR}${CONFDIR}"
+mkdir --parents "${DESTDIR}${PLUGINDIR}"
 
 # Copy the Mandos plugin runner
-copy_exec "$prefix"/lib/mandos/plugin-runner "${MANDOSDIR}"
+copy_exec "$prefix"/lib/mandos/plugin-runner "${DESTDIR}${MANDOSDIR}"
 
 # Copy the plugins
 
@@ -90,7 +66,6 @@
     fi
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
-	"*") :;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac
 done
@@ -99,46 +74,31 @@
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
-	"*") :;;
+	*~|.*|*.dpkg-old|*.dpkg-new|*.dpkg-divert) : ;;
 	*) copy_exec "$file" "${PLUGINDIR}";;
     esac
 done
 
 # GPGME needs /usr/bin/gpg
-if [ ! -e "${DESTDIR}/usr/bin/gpg" \
-    -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
-		2>/dev/null`" ]; then
+if ! [ -e "${DESTDIR}/usr/bin/gpg" ] \
+    && [ -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* 2>/dev/null`" ]; then
     copy_exec /usr/bin/gpg
 fi
 
-# Config files
+# Key files
 for file in /etc/mandos/*; do
     if [ -d "$file" ]; then
 	continue
     fi
     cp --archive --sparse=always "$file" "${DESTDIR}${CONFDIR}"
 done
-
-if [ ${mandos_user} != 65534 ]; then
-    PLUGINRUNNERCONF="${DESTDIR}${CONFDIR}/plugin-runner.conf"
-    echo "--userid=${mandos_user}" >> "$PLUGINRUNNERCONF"
-fi
-
-if [ ${mandos_group} != 65534 ]; then
-    PLUGINRUNNERCONF="${DESTDIR}${CONFDIR}/plugin-runner.conf"
-    echo "--groupid=${mandos_group}" >> "$PLUGINRUNNERCONF"
-fi
-
-# Key files 
-for file in  "$keydir"/*; do
-    if [ -d "$file" ]; then
-	continue
-    fi
-    cp --archive --sparse=always "$file" "${DESTDIR}${CONFDIR}"
-    chown ${mandos_user}:${mandos_group} \
-	"${DESTDIR}${CONFDIR}/`basename \"$file\"`"
-done
+# Create key ring files
+gpg --no-random-seed-file --quiet --batch --no-tty --armor \
+    --no-default-keyring --no-options --enable-dsa2 \
+    --homedir "${DESTDIR}${CONFDIR}" --no-permission-warning \
+    --trust-model always --import-options import-minimal \
+    --import "${DESTDIR}${CONFDIR}/seckey.txt"
+chown nobody "${DESTDIR}${CONFDIR}/secring.gpg"
 
 # /lib/mandos/plugin-runner will drop priviliges, but needs access to
 # its plugin directory and its config file.  However, since almost all
@@ -152,7 +112,7 @@
 # condition.  This umask is set by "initramfs-tools-hook-conf",
 # installed as "/usr/share/initramfs-tools/conf-hooks.d/mandos".)
 # 
-for full in "${MANDOSDIR}" "${CONFDIR}"; do
+for full in "${PLUGINDIR}" "${CONFDIR}"; do
     while [ "$full" != "/" ]; do
 	chmod a+rX "${DESTDIR}$full"
 	full="`dirname \"$full\"`"
@@ -162,11 +122,8 @@
 # Reset some other things to sane permissions which we have
 # inadvertently affected with our umask setting.
 for dir in / /bin /etc /keyscripts /sbin /scripts /usr /usr/bin; do
-    if [ -d "${DESTDIR}$dir" ]; then
-	chmod a+rX "${DESTDIR}$dir"
-    fi
+    chmod a+rX "${DESTDIR}$dir"
 done
 for dir in /lib /usr/lib; do
-    find "${DESTDIR}$dir" \! -perm -u+rw,g+r -prune -or -print0 \
-	| xargs --null --no-run-if-empty chmod a+rX
+    chmod --recursive a+rX "${DESTDIR}$dir"
 done

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2008-09-07 15:42:11 +0000
+++ initramfs-tools-script	2008-08-14 02:24:59 +0000
@@ -24,8 +24,6 @@
      ;;
 esac
 
-chmod a=rwxt /tmp
-
 test -w /conf/conf.d/cryptroot
 
 # Do not replace cryptroot file unless we need to.

=== modified file 'legalnotice.xml'
--- legalnotice.xml	2008-09-06 17:24:58 +0000
+++ legalnotice.xml	2008-08-31 15:06:39 +0000
@@ -4,24 +4,21 @@
 <legalnotice>
   <para>
     This manual page is free software: you can redistribute it and/or
-    modify it under the terms of the <acronym>GNU</acronym> General
-    Public License as published by the Free Software Foundation,
-    either version 3 of the License, or (at your option) any later
-    version.
+    modify it under the terms of the GNU General Public License as
+    published by the Free Software Foundation, either version 3 of the
+    License, or (at your option) any later version.
   </para>
   
   <para>
     This manual page is distributed in the hope that it will be
     useful, but WITHOUT ANY WARRANTY; without even the implied
     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-    See the <acronym>GNU</acronym> General Public License for more
-    details.
+    See the GNU General Public License for more details.
   </para>
   
   <para>
-    You should have received a copy of the <acronym>GNU</acronym>
-    General Public License along with this program.  If not, see
-    <ulink
-    url="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</ulink>.
+    You should have received a copy of the GNU General Public License
+    along with this program; If not, see <ulink
+    url="http://www.gnu.org/licenses/"/>.
   </para>
 </legalnotice>

=== modified file 'mandos'
--- mandos	2008-09-05 18:37:28 +0000
+++ mandos	2008-08-27 01:18:25 +0000
@@ -55,7 +55,6 @@
 import stat
 import logging
 import logging.handlers
-import pwd
 
 import dbus
 import gobject
@@ -518,7 +517,6 @@
     Attributes:
         settings:       Server settings
         clients:        Set() of Client objects
-        enabled:        Boolean; whether this server is activated yet
     """
     address_family = socket.AF_INET6
     def __init__(self, *args, **kwargs):
@@ -528,7 +526,6 @@
         if "clients" in kwargs:
             self.clients = kwargs["clients"]
             del kwargs["clients"]
-        self.enabled = False
         return super(type(self), self).__init__(*args, **kwargs)
     def server_bind(self):
         """This overrides the normal server_bind() function
@@ -565,11 +562,6 @@
 #                                            (self.settings
 #                                             ["interface"]))
             return super(type(self), self).server_bind()
-    def server_activate(self):
-        if self.enabled:
-            return super(type(self), self).server_activate()
-    def enable(self):
-        self.enabled = True
 
 
 def string_to_delta(interval):
@@ -766,41 +758,6 @@
     client_config.read(os.path.join(server_settings["configdir"],
                                     "clients.conf"))
     
-    clients = Set()
-    tcp_server = IPv6_TCPServer((server_settings["address"],
-                                 server_settings["port"]),
-                                tcp_handler,
-                                settings=server_settings,
-                                clients=clients)
-    pidfilename = "/var/run/mandos.pid"
-    try:
-        pidfile = open(pidfilename, "w")
-    except IOError, error:
-        logger.error("Could not open file %r", pidfilename)
-    
-    uid = 65534
-    gid = 65534
-    try:
-        uid = pwd.getpwnam("mandos").pw_uid
-    except KeyError:
-        try:
-            uid = pwd.getpwnam("nobody").pw_uid
-        except KeyError:
-            pass
-    try:
-        gid = pwd.getpwnam("mandos").pw_gid
-    except KeyError:
-        try:
-            gid = pwd.getpwnam("nogroup").pw_gid
-        except KeyError:
-            pass
-    try:
-        os.setuid(uid)
-        os.setgid(gid)
-    except OSError, error:
-        if error[0] != errno.EPERM:
-            raise error
-    
     global service
     service = AvahiService(name = server_settings["servicename"],
                            type = "_mandos._tcp", );
@@ -820,6 +777,7 @@
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
     
+    clients = Set()
     def remove_from_clients(client):
         clients.remove(client)
         if not clients:
@@ -847,18 +805,16 @@
         # Close all input and output, do double fork, etc.
         daemon()
     
+    pidfilename = "/var/run/mandos/mandos.pid"
+    pid = os.getpid()
     try:
-        pid = os.getpid()
+        pidfile = open(pidfilename, "w")
         pidfile.write(str(pid) + "\n")
         pidfile.close()
         del pidfile
     except IOError, err:
-        logger.error(u"Could not write to file %r with PID %d",
-                     pidfilename, pid)
-    except NameError:
-        # "pidfile" was never created
-        pass
-    del pidfilename
+        logger.error(u"Could not write %s file with PID %d",
+                     pidfilename, os.getpid())
     
     def cleanup():
         "Cleanup function; run on exit"
@@ -884,9 +840,11 @@
     for client in clients:
         client.start()
     
-    tcp_server.enable()
-    tcp_server.server_activate()
-    
+    tcp_server = IPv6_TCPServer((server_settings["address"],
+                                 server_settings["port"]),
+                                tcp_handler,
+                                settings=server_settings,
+                                clients=clients)
     # Find out what port we got
     service.port = tcp_server.socket.getsockname()[1]
     logger.info(u"Now listening on address %r, port %d, flowinfo %d,"

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2008-09-12 19:12:40 +0000
+++ mandos-clients.conf.xml	2008-08-31 15:06:39 +0000
@@ -4,7 +4,7 @@
 <!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY TIMESTAMP "2008-08-31">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -37,7 +37,7 @@
     </copyright>
     <xi:include href="legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&CONFNAME;</refentrytitle>
     <manvolnum>5</manvolnum>
@@ -49,11 +49,11 @@
       Configuration file for the Mandos server
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <synopsis>&CONFPATH;</synopsis>
   </refsynopsisdiv>
-  
+
   <refsect1 id="description">
     <title>DESCRIPTION</title>
     <para>
@@ -93,19 +93,16 @@
       start time expansion, see <xref linkend="expansion"/>.
     </para>
     <para>
-      Unknown options are ignored.  The used options are as follows:
+      Uknown options are ignored.  The used options are as follows:
     </para>
-    
+
     <variablelist>
-      
+
       <varlistentry>
 	<term><option>timeout<literal> = </literal><replaceable
 	>TIME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
 	    The timeout is how long the server will wait for a
 	    successful checker run until a client is considered
 	    invalid - that is, ineligible to get the data this server
@@ -126,15 +123,12 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>interval<literal> = </literal><replaceable
 	>TIME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
 	    How often to run the checker to confirm that a client is
 	    still up.  <emphasis>Note:</emphasis> a new checker will
 	    not be started if an old one is still running.  The server
@@ -149,15 +143,12 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>checker<literal> = </literal><replaceable
 	>COMMAND</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
 	    This option allows you to override the default shell
 	    command that the server will use to check if the client is
 	    still up.  Any output of the command will be ignored, only
@@ -183,9 +174,6 @@
 	><replaceable>HEXSTRING</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is <emphasis>required</emphasis>.
-	  </para>
-	  <para>
 	    This option sets the OpenPGP fingerprint that identifies
 	    the public key that clients authenticate themselves with
 	    through TLS.  The string needs to be in hexidecimal form,
@@ -199,11 +187,6 @@
 	>BASE64_ENCODED_DATA</replaceable></option></term>
 	<listitem>
 	  <para>
-	    If this option is not specified, the <option
-	    >secfile</option> option is <emphasis>required</emphasis>
-	    to be present.
-	  </para>
-	  <para>
 	    If present, this option must be set to a string of
 	    base64-encoded binary data.  It will be decoded and sent
 	    to the client matching the above
@@ -221,38 +204,36 @@
 	    lines is that a line beginning with white space adds to
 	    the value of the previous line, RFC 822-style.
 	  </para>
+	  <para>
+	    If this option is not specified, the <option
+	    >secfile</option> option is used instead, but one of them
+	    <emphasis>must</emphasis> be present.
+	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>secfile<literal> = </literal><replaceable
 	>FILENAME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is only used if <option>secret</option> is not
-	    specified, in which case this option is
-	    <emphasis>required</emphasis>.
-	  </para>
-	  <para>
 	    Similar to the <option>secret</option>, except the secret
 	    data is in an external file.  The contents of the file
 	    should <emphasis>not</emphasis> be base64-encoded, but
 	    will be sent to clients verbatim.
 	  </para>
+	  <para>
+	    This option is only used, and <emphasis>must</emphasis> be
+	    present, if <option>secret</option> is not specified.
+	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option><literal>host = </literal><replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
 	  <para>
-	    This option is <emphasis>optional</emphasis>, but highly
-	    <emphasis>recommended</emphasis> unless the
-	    <option>checker</option> option is modified to a
-	    non-standard value without <quote>%(host)s</quote> in it.
-	  </para>
-	  <para>
 	    Host name for this client.  This is not used by the server
 	    directly, but can be, and is by default, used by the
 	    checker.  See the <option>checker</option> option.
@@ -313,7 +294,7 @@
 	mode is needed to expose an error of this kind.
       </para>
     </refsect2>
-    
+
   </refsect1>
   
   <refsect1 id="files">
@@ -373,6 +354,7 @@
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 secfile = /etc/mandos/bar-secret
 timeout = 15m
+
       </programlisting>
     </informalexample>
   </refsect1>

=== modified file 'mandos-keygen'
--- mandos-keygen	2008-09-08 12:03:16 +0000
+++ mandos-keygen	2008-08-31 08:47:38 +0000
@@ -22,7 +22,7 @@
 
 VERSION="1.0"
 
-KEYDIR="/etc/keys/mandos"
+KEYDIR="/etc/mandos"
 KEYTYPE=DSA
 KEYLENGTH=2048
 SUBKEYTYPE=ELG-E
@@ -35,10 +35,6 @@
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
-if [ ! -d "$KEYDIR" ]; then
-    KEYDIR="/etc/mandos/keys"
-fi
-
 # Parse options
 TEMP=`getopt --options vhd:t:l:n:e:c:x:f \
     --longoptions version,help,password,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
@@ -112,20 +108,21 @@
 PUBKEYFILE="$KEYDIR/pubkey.txt"
 
 # Check for some invalid values
-if [ ! -d "$KEYDIR" ]; then
+if [ -d "$KEYDIR" ]; then :; else
     echo "$KEYDIR not a directory" >&2
     exit 1
 fi
-if [ ! -r "$KEYDIR" ]; then
-    echo "Directory $KEYDIR not readable" >&2
+if [ -w "$KEYDIR" ]; then :; else
+    echo "Directory $KEYDIR not writeable" >&2
+    exit 1
+fi
+
+if [ "$mode" = password -a -e "$KEYDIR/trustdb.gpg.lock" ]; then
+    echo "Key directory has locked trustdb; aborting." >&2
     exit 1
 fi
 
 if [ "$mode" = keygen ]; then
-    if [ ! -w "$KEYDIR" ]; then
-	echo "Directory $KEYDIR not writeable" >&2
-	exit 1
-    fi
     if [ -z "$KEYTYPE" ]; then
 	echo "Empty key type" >&2
 	exit 1
@@ -152,8 +149,8 @@
 	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) FORCE=0;;
     esac
     
-    if [ \( -e "$SECKEYFILE" -o -e "$PUBKEYFILE" \) \
-	-a "$FORCE" -eq 0 ]; then
+    if { [ -e "$SECKEYFILE" ] || [ -e "$PUBKEYFILE" ]; } \
+	&& [ "$FORCE" -eq 0 ]; then
 	echo "Refusing to overwrite old key files; use --force" >&2
 	exit 1
     fi
@@ -167,28 +164,35 @@
     fi
 
     # Create temporary gpg batch file
-    BATCHFILE="`mktemp -t mandos-keygen-batch.XXXXXXXXXX`"
+    BATCHFILE="`mktemp -t mandos-gpg-batch.XXXXXXXXXX`"
 fi
 
 if [ "$mode" = password ]; then
     # Create temporary encrypted password file
-    SECFILE="`mktemp -t mandos-keygen-secfile.XXXXXXXXXX`"
-fi
-
-# Create temporary key ring directory
-RINGDIR="`mktemp -d -t mandos-keygen-keyrings.XXXXXXXXXX`"
+    SECFILE="`mktemp -t mandos-gpg-secfile.XXXXXXXXXX`"
+fi
+
+# Create temporary key rings
+SECRING="`mktemp -t mandos-gpg-secring.XXXXXXXXXX`"
+PUBRING="`mktemp -t mandos-gpg-pubring.XXXXXXXXXX`"
+
+if [ "$mode" = password ]; then
+    # If a trustdb.gpg file does not already exist, schedule it for
+    # deletion when we are done.
+    if ! [ -e "$KEYDIR/trustdb.gpg" ]; then
+	TRUSTDB="$KEYDIR/trustdb.gpg"
+    fi
+fi
 
 # Remove temporary files on exit
 trap "
 set +e; \
-test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec*;
-test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
-rm --recursive --force \"$RINGDIR\";
+rm --force $PUBRING ${PUBRING}~ $BATCHFILE $TRUSTDB; \
+shred --remove $SECRING $SECFILE; \
 stty echo; \
 " EXIT
 
-umask 077
+umask 027
 
 if [ "$mode" = keygen ]; then
     # Create batch file for GnuPG
@@ -205,17 +209,18 @@
 	Expire-Date: $KEYEXPIRE
 	#Preferences: <string>
 	#Handle: <no-spaces>
-	#%pubring pubring.gpg
-	#%secring secring.gpg
+	%pubring $PUBRING
+	%secring $SECRING
 	%commit
 	EOF
     
     # Generate a new key in the key rings
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always \
+    gpg --no-random-seed-file --quiet --batch --no-tty \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
 	--gen-key "$BATCHFILE"
     rm --force "$BATCHFILE"
-    
+
     # Backup any old key files
     if cp --backup=numbered --force "$SECKEYFILE" "$SECKEYFILE" \
 	2>/dev/null; then
@@ -236,30 +241,38 @@
     fi
     
     # Export keys from key rings to key files
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --armor --export-options export-minimal \
-	--comment "$FILECOMMENT" --output "$SECKEYFILE" \
-	--export-secret-keys
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --armor --export-options export-minimal \
-	--comment "$FILECOMMENT" --output "$PUBKEYFILE" --export
+    gpg --no-random-seed-file --quiet --batch --no-tty --armor \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
+	--export-options export-minimal --comment "$FILECOMMENT" \
+	--output "$SECKEYFILE" --export-secret-keys
+    gpg --no-random-seed-file --quiet --batch --no-tty --armor \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
+	--export-options export-minimal --comment "$FILECOMMENT" \
+	--output "$PUBKEYFILE" --export
 fi
 
 if [ "$mode" = password ]; then
     # Import keys into temporary key rings
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor \
-	--import "$SECKEYFILE"
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor \
-	--import "$PUBKEYFILE"
-    
+    gpg --no-random-seed-file --quiet --batch --no-tty --armor \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--homedir "$KEYDIR" --no-permission-warning \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
+	--trust-model always --import "$SECKEYFILE"
+    gpg --no-random-seed-file --quiet --batch --no-tty --armor \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--homedir "$KEYDIR" --no-permission-warning \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
+	--trust-model always --import "$PUBKEYFILE"
+
     # Get fingerprint of key
-    FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
-	--fingerprint --with-colons \
-	| sed --quiet \
-	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
+    FINGERPRINT="`gpg --no-random-seed-file --quiet --batch --no-tty \
+	--armor --no-default-keyring --no-options --enable-dsa2 \
+	--homedir \"$KEYDIR\" --no-permission-warning \
+	--secret-keyring \"$SECRING\" --keyring \"$PUBRING\" \
+	--trust-model always --fingerprint --with-colons \
+	| sed -n -e '/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
     
     test -n "$FINGERPRINT"
     
@@ -267,10 +280,13 @@
     
     stty -echo
     echo -n "Enter passphrase: " >&2
-    head --lines=1 | tr --delete '\n' \
-	| gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
+    sed -e '1q' \
+	| gpg --no-random-seed-file --batch --no-tty --armor \
+	--no-default-keyring --no-options --enable-dsa2 \
+	--homedir "$KEYDIR" --no-permission-warning \
+	--secret-keyring "$SECRING" --keyring "$PUBRING" \
+	--trust-model always --encrypt --recipient "$FINGERPRINT" \
+	--comment "$FILECOMMENT" \
 	> "$SECFILE"
     echo >&2
     stty echo
@@ -281,7 +297,7 @@
 	fingerprint = $FINGERPRINT
 	secret =
 EOF
-    sed --quiet --expression='
+    sed -n -e '
 	/^-----BEGIN PGP MESSAGE-----$/,/^-----END PGP MESSAGE-----$/{
 	    /^$/,${
 		# Remove 24-bit Radix-64 checksum
@@ -300,5 +316,9 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec*
-rm --recursive --force "$RINGDIR"
+shred --remove "$SECRING"
+rm --force "$PUBRING" "${PUBRING}~"
+# Remove the trustdb, if one did not exist when we started
+if [ -n "$TRUSTDB" ]; then
+    rm --force "$TRUSTDB"
+fi

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2008-09-12 19:12:40 +0000
+++ mandos-keygen.xml	2008-08-31 15:06:39 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY TIMESTAMP "2008-08-31">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -36,7 +36,7 @@
     </copyright>
     <xi:include href="legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&COMMANDNAME;</refentrytitle>
     <manvolnum>8</manvolnum>
@@ -48,7 +48,7 @@
       Generate key and password for Mandos client and server.
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -159,7 +159,7 @@
     <para>
       <command>&COMMANDNAME;</command> is a program to generate the
       OpenPGP key used by
-      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <citerefentry><refentrytitle>password-request</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>.  The key is
       normally written to /etc/mandos for later installation into the
       initrd image, but this, and most other things, can be changed
@@ -197,7 +197,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--dir
 	<replaceable>DIRECTORY</replaceable></option></term>
@@ -210,7 +210,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--type
 	<replaceable>TYPE</replaceable></option></term>
@@ -222,7 +222,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--length
 	<replaceable>BITS</replaceable></option></term>
@@ -234,7 +234,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--subtype
 	<replaceable>KEYTYPE</replaceable></option></term>
@@ -247,7 +247,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--sublength
 	<replaceable>BITS</replaceable></option></term>
@@ -259,7 +259,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--email
 	<replaceable>ADDRESS</replaceable></option></term>
@@ -271,7 +271,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--comment
 	<replaceable>TEXT</replaceable></option></term>
@@ -284,7 +284,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--expire
 	<replaceable>TIME</replaceable></option></term>
@@ -298,7 +298,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--force</option></term>
 	<term><option>-f</option></term>
@@ -328,7 +328,7 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
+
   <refsect1 id="overview">
     <title>OVERVIEW</title>
     <xi:include href="overview.xml"/>
@@ -338,7 +338,7 @@
       <filename>clients.conf</filename> on the server.
     </para>
   </refsect1>
-  
+
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>
@@ -401,13 +401,14 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
-  
+
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <para>
+      None are known at this time.
+    </para>
+  </refsect1>
+
   <refsect1 id="example">
     <title>EXAMPLE</title>
     <informalexample>
@@ -454,7 +455,7 @@
       </para>
     </informalexample>
   </refsect1>
-  
+
   <refsect1 id="security">
     <title>SECURITY</title>
     <para>
@@ -469,7 +470,7 @@
       <manvolnum>8</manvolnum></citerefentry>.
     </para>
   </refsect1>
-  
+
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
@@ -479,7 +480,7 @@
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <citerefentry><refentrytitle>password-request</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2008-09-06 16:31:49 +0000
+++ mandos-options.xml	2008-09-03 05:04:40 +0000
@@ -6,7 +6,7 @@
 This file is used by both mandos(8) and mandos.conf(5), since these
 options can be used both on the command line and in the config file.
 
-It is also used for some texts by mandos-client(8mandos).
+It is also used for some texts by password-request(8mandos).
 -->
 
 <section>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2008-09-12 19:12:40 +0000
+++ mandos.conf.xml	2008-08-31 15:06:39 +0000
@@ -4,7 +4,7 @@
 <!ENTITY VERSION "1.0">
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY TIMESTAMP "2008-08-31">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -37,7 +37,7 @@
     </copyright>
     <xi:include href="legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&CONFNAME;</refentrytitle>
     <manvolnum>5</manvolnum>
@@ -49,11 +49,11 @@
       Configuration file for the Mandos server
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <synopsis>&CONFPATH;</synopsis>
   </refsynopsisdiv>
-  
+
   <refsect1 id="description">
     <title>DESCRIPTION</title>
     <para>
@@ -71,7 +71,7 @@
       <quote>#</quote> or <quote>;</quote> are ignored and may be used
       to provide comments.
     </para>
-    
+
   </refsect1>
   <refsect1>
     <title>OPTIONS</title>
@@ -84,7 +84,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="interface"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>address<literal> = </literal><replaceable
 	  >ADDRESS</replaceable></option></term>
@@ -92,7 +92,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="address"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>port<literal> = </literal><replaceable
 	>NUMBER</replaceable></option></term>
@@ -100,7 +100,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="port"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>debug<literal> = </literal>{ <literal
 	  >1</literal> | <literal>yes</literal> | <literal
@@ -111,7 +111,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="debug"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>priority<literal> = </literal><replaceable
 	>STRING</replaceable></option></term>
@@ -119,7 +119,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>servicename<literal> = </literal
 	><replaceable>NAME</replaceable></option></term>
@@ -144,7 +144,7 @@
     <para>
       The <literal>[DEFAULT]</literal> is necessary because the Python
       built-in module <systemitem class="library">ConfigParser</systemitem>
-      requires it.
+      requres it.
     </para>
   </refsect1>
   
@@ -185,7 +185,7 @@
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>
     </para>
-    
+
     <variablelist>
       <varlistentry>
 	<term>

=== modified file 'mandos.xml'
--- mandos.xml	2008-09-12 19:12:40 +0000
+++ mandos.xml	2008-09-02 17:42:53 +0000
@@ -3,7 +3,7 @@
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY TIMESTAMP "2008-09-02">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -36,7 +36,7 @@
     </copyright>
     <xi:include href="legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&COMMANDNAME;</refentrytitle>
     <manvolnum>8</manvolnum>
@@ -48,7 +48,7 @@
       Gives encrypted passwords to authenticated Mandos clients
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -100,7 +100,7 @@
       <arg choice="plain"><option>--check</option></arg>
     </cmdsynopsis>
   </refsynopsisdiv>
-  
+
   <refsect1 id="description">
     <title>DESCRIPTION</title>
     <para>
@@ -186,7 +186,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="debug"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
@@ -194,7 +194,7 @@
 	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--servicename
 	<replaceable>NAME</replaceable></option></term>
@@ -203,7 +203,7 @@
 		      xpointer="servicename"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--configdir
 	<replaceable>DIRECTORY</replaceable></option></term>
@@ -218,7 +218,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--version</option></term>
 	<listitem>
@@ -229,7 +229,7 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
+
   <refsect1 id="overview">
     <title>OVERVIEW</title>
     <xi:include href="overview.xml"/>
@@ -239,7 +239,7 @@
       <acronym>RAM</acronym> disk environment.
     </para>
   </refsect1>
-  
+
   <refsect1 id="protocol">
     <title>NETWORK PROTOCOL</title>
     <para>
@@ -297,7 +297,7 @@
       </row>
     </tbody></tgroup></table>
   </refsect1>
-  
+
   <refsect1 id="checking">
     <title>CHECKING</title>
     <para>
@@ -311,7 +311,7 @@
       <manvolnum>5</manvolnum></citerefentry>.
     </para>
   </refsect1>
-  
+
   <refsect1 id="logging">
     <title>LOGGING</title>
     <para>
@@ -321,7 +321,7 @@
       and also show them on the console.
     </para>
   </refsect1>
-  
+
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>
@@ -329,7 +329,7 @@
       critical error is encountered.
     </para>
   </refsect1>
-  
+
   <refsect1 id="environment">
     <title>ENVIRONMENT</title>
     <variablelist>
@@ -349,7 +349,7 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
+
   <refsect1 id="file">
     <title>FILES</title>
     <para>
@@ -379,7 +379,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/var/run/mandos.pid</filename></term>
+	<term><filename>/var/run/mandos/mandos.pid</filename></term>
 	<listitem>
 	  <para>
 	    The file containing the process id of
@@ -434,11 +434,7 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
-      The console log messages does not show a time stamp.
-    </para>
-    <para>
-      This server does not check the expire time of clients’ OpenPGP
-      keys.
+      The console log messages does not show a timestamp.
     </para>
   </refsect1>
   
@@ -479,7 +475,7 @@
       </para>
     </informalexample>
   </refsect1>
-  
+
   <refsect1 id="security">
     <title>SECURITY</title>
     <refsect2 id="SERVER">
@@ -487,8 +483,8 @@
       <para>
 	Running this <command>&COMMANDNAME;</command> server program
 	should not in itself present any security risk to the host
-	computer running it.  The program switches to a non-root user
-	soon after startup.
+	computer running it.  The program does not need any special
+	privileges to run, and is designed to run as a non-root user.
       </para>
     </refsect2>
     <refsect2 id="CLIENTS">
@@ -529,12 +525,12 @@
       </para>
       <para>
 	For more details on client-side security, see
-	<citerefentry><refentrytitle>mandos-client</refentrytitle>
+	<citerefentry><refentrytitle>password-request</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.
       </para>
     </refsect2>
   </refsect1>
-  
+
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
@@ -543,7 +539,7 @@
 	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
 	<refentrytitle>mandos.conf</refentrytitle>
 	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos-client</refentrytitle>
+	<refentrytitle>password-request</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>, <citerefentry>
 	<refentrytitle>sh</refentrytitle><manvolnum>1</manvolnum>
       </citerefentry>

=== modified file 'overview.xml'
--- overview.xml	2008-09-13 15:36:18 +0000
+++ overview.xml	2008-09-01 08:29:23 +0000
@@ -6,12 +6,10 @@
   encrypted root file systems and at the same time be capable of
   remote and/or unattended reboots.  The computers run a small client
   program in the initial <acronym>RAM</acronym> disk environment which
-  will communicate with a server over a network.  All network
-  communication is encrypted using <acronym>TLS</acronym>.  The
-  clients are identified by the server using an OpenPGP key; each
-  client has one unique to it.  The server sends the clients an
-  encrypted password.  The encrypted password is decrypted by the
-  clients using the same OpenPGP key, and the password is then used to
-  unlock the root file system, whereupon the computers can continue
-  booting normally.
+  will communicate with a server over a network.  The clients are
+  identified by the server using a OpenPGP key; each client has one
+  unique to it.  The server sends the clients an encrypted password.
+  The encrypted password is decrypted by the clients using the same
+  OpenPGP key, and the password is then used to unlock the root file
+  system, whereupon the computers can continue booting normally.
 </para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2008-09-19 00:00:51 +0000
+++ plugin-runner.c	2008-09-02 06:13:47 +0000
@@ -72,6 +72,8 @@
 const char *argp_program_version = "plugin-runner 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
+struct plugin;
+
 typedef struct plugin{
   char *name;			/* can be NULL or any plugin name */
   char **argv;
@@ -94,7 +96,7 @@
 
 static plugin *plugin_list = NULL;
 
-/* Gets an existing plugin based on name,
+/* Gets a existing plugin based on name,
    or if none is found, creates a new one */
 static plugin *getplugin(char *name){
   /* Check for exiting plugin with that name */
@@ -116,7 +118,7 @@
       return NULL;
     }
   }
-  
+
   *new_plugin = (plugin) { .name = copy_name,
 			   .argc = 1,
 			   .disabled = false,
@@ -185,10 +187,10 @@
   size_t namelen = (size_t)(strchrnul(def, '=') - def);
   /* Search for this environment variable */
   for(char **e = p->environ; *e != NULL; e++){
-    if(strncmp(*e, def, namelen + 1) == 0){
+    if(strncmp(*e, def, namelen+1) == 0){
       /* It already exists */
       if(replace){
-	char *new = realloc(*e, strlen(def) + 1);
+	char *new = realloc(*e, strlen(def));
 	if(new == NULL){
 	  return false;
 	}
@@ -206,7 +208,8 @@
  * Descriptor Flags".
  * *Note File Descriptor Flags:(libc)Descriptor Flags.
  */
-static int set_cloexec_flag(int fd){
+static int set_cloexec_flag(int fd)
+{
   int ret = fcntl(fd, F_GETFD, 0);
   /* If reading the flags failed, return error indication now. */
   if(ret < 0){
@@ -219,7 +222,7 @@
 
 /* Mark processes as completed when they exit, and save their exit
    status. */
-static void handle_sigchld(__attribute__((unused)) int sig){
+void handle_sigchld(__attribute__((unused)) int sig){
   while(true){
     plugin *proc = plugin_list;
     int status;
@@ -235,7 +238,7 @@
       /* No child processes */
       break;
     }
-    
+
     /* A child exited, find it in process_list */
     while(proc != NULL and proc->pid != pid){
       proc = proc->next;
@@ -250,8 +253,11 @@
 }
 
 /* Prints out a password to stdout */
-static bool print_out_password(const char *buffer, size_t length){
+bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
+  if(length>0 and buffer[length-1] == '\n'){
+    length--;
+  }
   for(size_t written = 0; written < length; written += (size_t)ret){
     ret = TEMP_FAILURE_RETRY(write(STDOUT_FILENO, buffer + written,
 				   length - written));
@@ -391,28 +397,36 @@
       if(arg == NULL){
 	break;
       }
-      if(not add_environment(getplugin(NULL), arg, true)){
-	perror("add_environment");
+      {
+	char *envdef = strdup(arg);
+	if(envdef == NULL){
+	  break;
+	}
+	if(not add_environment(getplugin(NULL), envdef, true)){
+	  perror("add_environment");
+	}
       }
       break;
     case 'o':			/* --options-for */
       if (arg != NULL){
 	char *p_name = strsep(&arg, ":");
-	if(p_name[0] == '\0' or arg == NULL){
+	if(p_name[0] == '\0'){
 	  break;
 	}
 	char *opt = strsep(&arg, ":");
-	if(opt[0] == '\0' or opt == NULL){
+	if(opt[0] == '\0'){
 	  break;
 	}
-	char *p;
-	while((p = strsep(&opt, ",")) != NULL){
-	  if(p[0] == '\0'){
-	    continue;
-	  }
-	  if(not add_argument(getplugin(p_name), p)){
-	    perror("add_argument");
-	    return ARGP_ERR_UNKNOWN;
+	if(opt != NULL){
+	  char *p;
+	  while((p = strsep(&opt, ",")) != NULL){
+	    if(p[0] == '\0'){
+	      continue;
+	    }
+	    if(not add_argument(getplugin(p_name), p)){
+	      perror("add_argument");
+	      return ARGP_ERR_UNKNOWN;
+	    }
 	  }
 	}
       }
@@ -426,8 +440,12 @@
 	if(envdef == NULL){
 	  break;
 	}
-	*envdef = '\0';
-	if(not add_environment(getplugin(arg), envdef+1, true)){
+	char *p_name = strndup(arg, (size_t) (envdef-arg));
+	if(p_name == NULL){
+	  break;
+	}
+	envdef++;
+	if(not add_environment(getplugin(p_name), envdef, true)){
 	  perror("add_environment");
 	}
       }
@@ -451,7 +469,6 @@
       }
       break;
     case 128:			/* --plugin-dir */
-      free(plugindir);
       plugindir = strdup(arg);
       if(plugindir == NULL){
 	perror("strdup");
@@ -470,12 +487,7 @@
       debug = true;
       break;
     case ARGP_KEY_ARG:
-      /* Cryptsetup always passes an argument, which is an empty
-	 string if "none" was specified in /etc/crypttab.  So if
-	 argument was empty, we ignore it silently. */
-      if(arg[0] != '\0'){
-	fprintf(stderr, "Ignoring unknown argument \"%s\"\n", arg);
-      }
+      fprintf(stderr, "Ignoring unknown argument \"%s\"\n", arg);
       break;
     case ARGP_KEY_END:
       break;
@@ -500,7 +512,6 @@
     case 128:			/* --plugin-dir */
       break;
     case 129:			/* --config-file */
-      free(argfile);
       argfile = strdup(arg);
       if(argfile == NULL){
 	perror("strdup");
@@ -736,11 +747,7 @@
     }
 
     char *filename;
-    if(plugindir == NULL){
-      ret = asprintf(&filename, PDIR "/%s", dirst->d_name);
-    } else {
-      ret = asprintf(&filename, "%s/%s", plugindir, dirst->d_name);
-    }
+    ret = asprintf(&filename, "%s/%s", plugindir, dirst->d_name);
     if(ret < 0){
       perror("asprintf");
       continue;
@@ -935,7 +942,7 @@
     }
     /* OK, now either a process completed, or something can be read
        from one of them */
-    for(plugin *proc = plugin_list; proc != NULL;){
+    for(plugin *proc = plugin_list; proc != NULL; proc = proc->next){
       /* Is this process completely done? */
       if(proc->eof and proc->completed){
 	/* Only accept the plugin output if it exited cleanly */
@@ -968,7 +975,7 @@
 	    exitstatus = EXIT_FAILURE;
 	    goto fallback;
 	  }
-	  
+	  free_plugin(proc);
 	  /* We are done modifying process list, so unblock signal */
 	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
 			     NULL);
@@ -981,10 +988,6 @@
 	  if(plugin_list == NULL){
 	    break;
 	  }
-	  
-	  plugin *next_plugin = proc->next;
-	  free_plugin(proc);
-	  proc = next_plugin;
 	  continue;
 	}
 	
@@ -1002,7 +1005,6 @@
       /* This process has not completed.  Does it have any output? */
       if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
 	/* This process had nothing to say at this time */
-	proc = proc->next;
 	continue;
       }
       /* Before reading, make the process' data buffer large enough */
@@ -1021,7 +1023,6 @@
 		 BUFFER_SIZE);
       if(ret < 0){
 	/* Read error from this process; ignore the error */
-	proc = proc->next;
 	continue;
       }
       if(ret == 0){
@@ -1042,13 +1043,7 @@
     bool bret;
     fprintf(stderr, "Going to fallback mode using getpass(3)\n");
     char *passwordbuffer = getpass("Password: ");
-    size_t len = strlen(passwordbuffer);
-    /* Strip trailing newline */
-    if(len > 0 and passwordbuffer[len-1] == '\n'){
-      passwordbuffer[len-1] = '\0'; /* not strictly necessary */
-      len--;
-    }
-    bret = print_out_password(passwordbuffer, len);
+    bret = print_out_password(passwordbuffer, strlen(passwordbuffer));
     if(not bret){
       perror("print_out_password");
       exitstatus = EXIT_FAILURE;

=== removed file 'plugin-runner.conf'
--- plugin-runner.conf	2008-09-06 16:31:49 +0000
+++ plugin-runner.conf	1970-01-01 00:00:00 +0000
@@ -1,9 +0,0 @@
-## This is the configuration file for plugin-runner.  It should be
-## installed as "/etc/mandos/plugin-runner.conf", which will be copied
-## to "/conf/conf.d/mandos/plugin-runner.conf" in the initrd.img file.
-## 
-## The default network interface for mandos-client(8mandos) is
-## "eth0".  Uncomment this line and change it if necessary.
-## 
-
-#--options-for=mandos-client:--interface=eth0

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2008-09-19 00:00:51 +0000
+++ plugin-runner.xml	2008-09-02 13:04:42 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2008-09-19">
+<!ENTITY TIMESTAMP "2008-09-02">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -36,7 +36,7 @@
     </copyright>
     <xi:include href="legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&COMMANDNAME;</refentrytitle>
     <manvolnum>8mandos</manvolnum>
@@ -45,19 +45,19 @@
   <refnamediv>
     <refname><command>&COMMANDNAME;</command></refname>
     <refpurpose>
-      Run Mandos plugins, pass data from first to succeed.
+      Run Mandos plugins.  Pass data from first succesful one.
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
       <group rep="repeat">
 	<arg choice="plain"><option>--global-env=<replaceable
-	>ENV</replaceable><literal>=</literal><replaceable
+	>VAR</replaceable><literal>=</literal><replaceable
 	>value</replaceable></option></arg>
 	<arg choice="plain"><option>-G
-	<replaceable>ENV</replaceable><literal>=</literal><replaceable
+	<replaceable>VAR</replaceable><literal>=</literal><replaceable
 	>value</replaceable> </option></arg>
       </group>
       <sbr/>
@@ -140,11 +140,11 @@
     <title>DESCRIPTION</title>
     <para>
       <command>&COMMANDNAME;</command> is a program which is meant to
-      be specified as a <quote>keyscript</quote> for the root disk in
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.  The aim of this
-      program is therefore to output a password, which then
-      <citerefentry><refentrytitle>cryptsetup</refentrytitle>
+      be specified as <quote>keyscript</quote> in <citerefentry>
+      <refentrytitle>crypttab</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry> for the root disk.  The
+      aim of this program is therefore to output a password, which
+      then <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry> will use to unlock the
       root disk.
     </para>
@@ -170,10 +170,10 @@
     <variablelist>
       <varlistentry>
 	<term><option>--global-env
-	<replaceable>ENV</replaceable><literal>=</literal><replaceable
+	<replaceable>VAR</replaceable><literal>=</literal><replaceable
 	>value</replaceable></option></term>
 	<term><option>-G
-	<replaceable>ENV</replaceable><literal>=</literal><replaceable
+	<replaceable>VAR</replaceable><literal>=</literal><replaceable
 	>value</replaceable></option></term>
 	<listitem>
 	  <para>
@@ -247,7 +247,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--disable
 	<replaceable>PLUGIN</replaceable></option></term>
@@ -261,7 +261,7 @@
 	  </para>	
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--enable
 	<replaceable>PLUGIN</replaceable></option></term>
@@ -272,11 +272,11 @@
 	    Re-enable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  This is only useful to
 	    undo a previous <option>--disable</option> option, maybe
-	    from the configuration file.
+	    from the config file.
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--groupid
 	<replaceable>ID</replaceable></option></term>
@@ -289,7 +289,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--userid
 	<replaceable>ID</replaceable></option></term>
@@ -302,7 +302,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--plugin-dir
 	<replaceable>DIRECTORY</replaceable></option></term>
@@ -365,7 +365,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--version</option></term>
 	<term><option>-V</option></term>
@@ -377,7 +377,7 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
+
   <refsect1 id="overview">
     <title>OVERVIEW</title>
     <xi:include href="overview.xml"/>
@@ -403,7 +403,7 @@
       code will make this plugin-runner output the password from that
       plugin, stop any other plugins, and exit.
     </para>
-    
+
     <refsect2 id="writing_plugins">
       <title>WRITING PLUGINS</title>
       <para>
@@ -416,11 +416,6 @@
 	console.
       </para>
       <para>
-	If the password is a single-line, manually entered passprase,
-	a final trailing newline character should
-	<emphasis>not</emphasis> be printed.
-      </para>
-      <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
 	services not available there.
@@ -433,8 +428,8 @@
       </para>
       <para>
 	The plugin must not use resources, like for instance reading
-	from the standard input, without knowing that no other plugin
-	is also using it.
+	from the standard input, without knowing that no other plugins
+	are also using it.
       </para>
       <para>
 	It is useful, but not required, for the plugin to take the
@@ -472,7 +467,7 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.
+      optins.
     </para>
   </refsect1>
   
@@ -515,13 +510,11 @@
     </para>
   </refsect1>
   
-  <refsect1 id="bugs">
-    <title>BUGS</title>
-    <para>
-      The <option>--config-file</option> option is ignored when
-      specified from within a configuration file.
-    </para>
-  </refsect1>
+<!--   <refsect1 id="bugs"> -->
+<!--     <title>BUGS</title> -->
+<!--     <para> -->
+<!--     </para> -->
+<!--   </refsect1> -->
   
   <refsect1 id="examples">
     <title>EXAMPLE</title>
@@ -569,15 +562,15 @@
     </informalexample>
     <informalexample>
       <para>
-	Run plugins from a different directory, read a different
-	configuration file, and add two options to the
-	<citerefentry><refentrytitle >mandos-client</refentrytitle>
+	Run plugins from a different directory and add a special
+	option to the <citerefentry><refentrytitle
+	>password-request</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry> plugin:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=/etc/keys/mandos/pubkey.txt,--seckey=/etc/keys/mandos/seckey.txt</userinput>
+<userinput>&COMMANDNAME;  --plugin-dir=plugins.d --options-for=password-request:--keydir=keydir</userinput>
 
       </para>
     </informalexample>
@@ -591,16 +584,16 @@
       non-privileged.  This user and group is then what all plugins
       will be started as.  Therefore, the only way to run a plugin as
       a privileged user is to have the set-user-ID or set-group-ID bit
-      set on the plugin executable file (see <citerefentry>
+      set on the plugin executable files (see <citerefentry>
       <refentrytitle>execve</refentrytitle><manvolnum>2</manvolnum>
       </citerefentry>).
     </para>
     <para>
       If this program is used as a keyscript in <citerefentry
       ><refentrytitle>crypttab</refentrytitle><manvolnum>5</manvolnum>
-      </citerefentry>, there is a slight risk that if this program
-      fails to work, there might be no way to boot the system except
-      for booting from another media and editing the initial RAM disk
+      </citerefentry>, there is a risk that if this program fails to
+      work, there might be no way to boot the system except for
+      booting from another media and editing the initial RAM disk
       image to not run this program.  This is, however, unlikely,
       since the <citerefentry><refentrytitle
       >password-prompt</refentrytitle><manvolnum>8mandos</manvolnum>
@@ -625,7 +618,7 @@
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>password-prompt</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <citerefentry><refentrytitle>password-request</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2008-09-07 01:44:44 +0000
+++ plugins.d/password-prompt.c	2008-08-29 05:53:59 +0000
@@ -216,11 +216,6 @@
       status = EXIT_SUCCESS;
       /* Make n = data size instead of allocated buffer size */
       n = (size_t)ret;
-      /* Strip final newline */
-      if(n>0 and buffer[n-1] == '\n'){
-	buffer[n-1] = '\0';	/* not strictly necessary */
-	n--;
-      }
       size_t written = 0;
       while(written < n){
 	ret = write(STDOUT_FILENO, buffer + written, n - written);
@@ -249,8 +244,6 @@
       fprintf(stderr, "getline() returned 0, retrying.\n");
     }
   }
-
-  free(buffer);
   
   if (debug){
     fprintf(stderr, "Restoring terminal attributes\n");
@@ -263,9 +256,6 @@
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);
   }
-  if(status == EXIT_SUCCESS){
-    fputc('\n', stderr);
-  }
   
   return status;
 }

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2008-09-06 16:31:49 +0000
+++ plugins.d/password-prompt.xml	2008-09-01 08:29:23 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2008-09-06">
+<!ENTITY TIMESTAMP "2008-09-01">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -87,7 +87,7 @@
       is not very useful on its own.  This program is really meant to
       run as a plugin in the <application>Mandos</application>
       client-side system, where it is used as a fallback and
-      alternative to retrieving passwords from a <application
+      alternative to retriving passwords from a <application
       >Mandos</application> server.
     </para>
     <para>
@@ -240,7 +240,7 @@
       <para>
 	Show a prefix before the prompt; in this case, a host name.
 	It might be useful to be reminded of which host needs a
-	password, in case of <acronym>KVM</acronym> switches, etc.
+	password, in case of KVM switches, etc.
       </para>
       <para>
 
@@ -270,7 +270,7 @@
       >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum>
       </citerefentry>, and will, when run standalone, outside, in a
       normal environment, immediately output on its standard output
-      any presumably secret password it just received.  Therefore,
+      any presumably secret password it just recieved.  Therefore,
       when running this program standalone (which should never
       normally be done), take care not to type in any real secret
       password by force of habit, since it would then immediately be
@@ -290,7 +290,7 @@
     <para>
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>
-      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <citerefentry><refentrytitle>password-request</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>,

=== renamed file 'plugins.d/mandos-client.c' => 'plugins.d/password-request.c'
--- plugins.d/mandos-client.c	2008-09-07 01:44:44 +0000
+++ plugins.d/password-request.c	2008-09-03 05:04:40 +0000
@@ -47,24 +47,21 @@
 #include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, INET6_ADDRSTRLEN,
-				   uid_t, gid_t, open(), opendir(), DIR */
-#include <sys/stat.h>		/* open() */
+				   uid_t, gid_t */
+#include <inttypes.h>		/* PRIu16 */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   struct in6_addr, inet_pton(),
 				   connect() */
-#include <fcntl.h>		/* open() */
-#include <dirent.h>		/* opendir(), struct dirent, readdir() */
-#include <inttypes.h>		/* PRIu16 */
 #include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno */
 #include <time.h>		/* time() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
 				   if_nametoindex(), IF_NAMESIZE */
-#include <netinet/in.h>
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), setuid(),
 				   setgid() */
+#include <netinet/in.h>
 #include <arpa/inet.h>		/* inet_pton(), htons */
 #include <iso646.h>		/* not, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -101,17 +98,10 @@
 
 #define BUFFER_SIZE 256
 
-/*
-  #define PATHDIR "/conf/conf.d/mandos"
-*/
-
-#define PATHDIR "/conf/conf.d/mandos"
-#define SECKEY "seckey.txt"
-#define PUBKEY "pubkey.txt"
-
 bool debug = false;
+static const char *keydir = "/conf/conf.d/mandos";
 static const char mandos_protocol_version[] = "1";
-const char *argp_program_version = "mandos-client 1.0";
+const char *argp_program_version = "password-request 1.0";
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 /* Used for passing in values through the Avahi callback functions */
@@ -122,7 +112,6 @@
   unsigned int dh_bits;
   gnutls_dh_params_t dh_params;
   const char *priority;
-  gpgme_ctx_t ctx;
 } mandos_context;
 
 /*
@@ -143,52 +132,23 @@
 }
 
 /* 
- * Initialize GPGME.
+ * Decrypt OpenPGP data using keyrings in HOMEDIR.
+ * Returns -1 on error
  */
-static bool init_gpgme(mandos_context *mc, const char *seckey,
-		       const char *pubkey, const char *tempdir){
-  int ret;
+static ssize_t pgp_packet_decrypt (const char *cryptotext,
+				   size_t crypto_size,
+				   char **plaintext,
+				   const char *homedir){
+  gpgme_data_t dh_crypto, dh_plain;
+  gpgme_ctx_t ctx;
   gpgme_error_t rc;
+  ssize_t ret;
+  size_t plaintext_capacity = 0;
+  ssize_t plaintext_length = 0;
   gpgme_engine_info_t engine_info;
   
-  
-  /*
-   * Helper function to insert pub and seckey to the enigne keyring.
-   */
-  bool import_key(const char *filename){
-    int fd;
-    gpgme_data_t pgp_data;
-    
-    fd = TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
-    if(fd == -1){
-      perror("open");
-      return false;
-    }
-    
-    rc = gpgme_data_new_from_fd(&pgp_data, fd);
-    if (rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
-	      gpgme_strsource(rc), gpgme_strerror(rc));
-      return false;
-    }
-    
-    rc = gpgme_op_import(mc->ctx, pgp_data);
-    if (rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
-	      gpgme_strsource(rc), gpgme_strerror(rc));
-      return false;
-    }
-    
-    ret = TEMP_FAILURE_RETRY(close(fd));
-    if(ret == -1){
-      perror("close");
-    }
-    gpgme_data_release(pgp_data);
-    return true;
-  }
-  
   if (debug){
-    fprintf(stderr, "Initialize gpgme\n");
+    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Init GPGME */
@@ -197,60 +157,27 @@
   if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return false;
+    return -1;
   }
   
-    /* Set GPGME home directory for the OpenPGP engine only */
+  /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info (&engine_info);
   if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return false;
+    return -1;
   }
   while(engine_info != NULL){
     if(engine_info->protocol == GPGME_PROTOCOL_OpenPGP){
       gpgme_set_engine_info(GPGME_PROTOCOL_OpenPGP,
-			    engine_info->file_name, tempdir);
+			    engine_info->file_name, homedir);
       break;
     }
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
-    return false;
-  }
-  
-  /* Create new GPGME "context" */
-  rc = gpgme_new(&(mc->ctx));
-  if (rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
-    return false;
-  }
-  
-  if (not import_key(pubkey) or not import_key(seckey)){
-    return false;
-  }
-  
-  return true; 
-}
-
-/* 
- * Decrypt OpenPGP data.
- * Returns -1 on error
- */
-static ssize_t pgp_packet_decrypt (const mandos_context *mc,
-				   const char *cryptotext,
-				   size_t crypto_size,
-				   char **plaintext){
-  gpgme_data_t dh_crypto, dh_plain;
-  gpgme_error_t rc;
-  ssize_t ret;
-  size_t plaintext_capacity = 0;
-  ssize_t plaintext_length = 0;
-  
-  if (debug){
-    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Could not set GPGME home dir to %s\n", homedir);
+    return -1;
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
@@ -271,16 +198,25 @@
     return -1;
   }
   
+  /* Create new GPGME "context" */
+  rc = gpgme_new(&ctx);
+  if (rc != GPG_ERR_NO_ERROR){
+    fprintf(stderr, "bad gpgme_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
+    plaintext_length = -1;
+    goto decrypt_end;
+  }
+  
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
-  rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
+  rc = gpgme_op_decrypt(ctx, dh_crypto, dh_plain);
   if (rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if (debug){
       gpgme_decrypt_result_t result;
-      result = gpgme_op_decrypt_result(mc->ctx);
+      result = gpgme_op_decrypt_result(ctx);
       if (result == NULL){
 	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
@@ -315,7 +251,7 @@
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
   if (gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET) == -1){
-    perror("gpgme_data_seek");
+    perror("pgpme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
   }
@@ -412,8 +348,8 @@
   }
   
   if(debug){
-    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
-	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
+    fprintf(stderr, "Attempting to use OpenPGP certificate %s"
+	    " and keyfile %s as GnuTLS credentials\n", pubkeyfilename,
 	    seckeyfilename);
   }
   
@@ -424,7 +360,7 @@
     fprintf(stderr,
 	    "Error[%d] while reading the OpenPGP key pair ('%s',"
 	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf(stderr, "The GnuTLS error is: %s\n",
+    fprintf(stdout, "The GnuTLS error is: %s\n",
 	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
@@ -451,7 +387,6 @@
   
   gnutls_certificate_free_credentials(mc->cred);
   gnutls_global_deinit();
-  gnutls_dh_params_deinit(mc->dh_params);
   return -1;
 }
 
@@ -675,9 +610,10 @@
   gnutls_bye (session, GNUTLS_SHUT_RDWR);
   
   if (buffer_length > 0){
-    decrypted_buffer_size = pgp_packet_decrypt(mc, buffer,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
 					       buffer_length,
-					       &decrypted_buffer);
+					       &decrypted_buffer,
+					       keydir);
     if (decrypted_buffer_size >= 0){
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
@@ -706,10 +642,7 @@
   
  mandos_end:
   free(buffer);
-  ret = TEMP_FAILURE_RETRY(close(tcp_sd));
-  if(ret == -1){
-    perror("close");
-  }
+  close(tcp_sd);
   gnutls_deinit (session);
   return retval;
 }
@@ -811,6 +744,18 @@
   }
 }
 
+/* Combines file name and path and returns the malloced new
+   string. some sane checks could/should be added */
+static char *combinepath(const char *first, const char *second){
+  char *tmp;
+  int ret = asprintf(&tmp, "%s/%s", first, second);
+  if(ret < 0){
+    return NULL;
+  }
+  return tmp;
+}
+
+
 int main(int argc, char *argv[]){
     AvahiSServiceBrowser *sb = NULL;
     int error;
@@ -822,16 +767,15 @@
     uid_t uid;
     gid_t gid;
     char *connect_to = NULL;
-    char tempdir[] = "/tmp/mandosXXXXXX";
     AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
-    const char *seckey = PATHDIR "/" SECKEY;
-    const char *pubkey = PATHDIR "/" PUBKEY;
-    
+    char *pubkeyfilename = NULL;
+    char *seckeyfilename = NULL;
+    const char *pubkeyname = "pubkey.txt";
+    const char *seckeyname = "seckey.txt";
     mandos_context mc = { .simple_poll = NULL, .server = NULL,
 			  .dh_bits = 1024, .priority = "SECURE256"
 			  ":!CTYPE-X.509:+CTYPE-OPENPGP" };
     bool gnutls_initalized = false;
-    bool gpgme_initalized = false;
     
     {
       struct argp_option options[] = {
@@ -846,6 +790,10 @@
 	  .doc = "Interface that will be used to search for Mandos"
 	  " servers",
 	  .group = 1 },
+	{ .name = "keydir", .key = 'd',
+	  .arg = "DIRECTORY",
+	  .doc = "Directory to read the OpenPGP key files from",
+	  .group = 1 },
 	{ .name = "seckey", .key = 's',
 	  .arg = "FILE",
 	  .doc = "OpenPGP secret key file base name",
@@ -880,11 +828,14 @@
 	case 'i':		/* --interface */
 	  interface = arg;
 	  break;
+	case 'd':		/* --keydir */
+	  keydir = arg;
+	  break;
 	case 's':		/* --seckey */
-	  seckey = arg;
+	  seckeyname = arg;
 	  break;
 	case 'p':		/* --pubkey */
-	  pubkey = arg;
+	  pubkeyname = arg;
 	  break;
 	case 129:		/* --dh-bits */
 	  errno = 0;
@@ -919,6 +870,29 @@
       }
     }
     
+    pubkeyfilename = combinepath(keydir, pubkeyname);
+    if (pubkeyfilename == NULL){
+      perror("combinepath");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+    
+    seckeyfilename = combinepath(keydir, seckeyname);
+    if (seckeyfilename == NULL){
+      perror("combinepath");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+    
+    ret = init_gnutls_global(&mc, pubkeyfilename, seckeyfilename);
+    if (ret == -1){
+      fprintf(stderr, "init_gnutls_global failed\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    } else {
+      gnutls_initalized = true;
+    }
+    
     /* If the interface is down, bring it up */
     {
       sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
@@ -943,10 +917,7 @@
 	  goto end;
 	}
       }
-      ret = TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror("close");
-      }
+      close(sd);
     }
     
     uid = getuid();
@@ -962,29 +933,6 @@
       perror("setgid");
     }
     
-    ret = init_gnutls_global(&mc, pubkey, seckey);
-    if (ret == -1){
-      fprintf(stderr, "init_gnutls_global failed\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    } else {
-      gnutls_initalized = true;
-    }
-    
-    if(mkdtemp(tempdir) == NULL){
-      perror("mkdtemp");
-      tempdir[0] = '\0';
-      goto end;
-    }
-    
-    if(not init_gpgme(&mc, pubkey, seckey, tempdir)){
-      fprintf(stderr, "gpgme_initalized failed\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    } else {
-      gpgme_initalized = true;
-    }
-    
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
@@ -1095,53 +1043,13 @@
     
     if (mc.simple_poll != NULL)
         avahi_simple_poll_free(mc.simple_poll);
+    free(pubkeyfilename);
+    free(seckeyfilename);
     
     if (gnutls_initalized){
       gnutls_certificate_free_credentials(mc.cred);
       gnutls_global_deinit ();
-      gnutls_dh_params_deinit(mc.dh_params);
-    }
-    
-    if(gpgme_initalized){
-      gpgme_release(mc.ctx);
-    }
-    
-    /* Removes the temp directory used by GPGME */
-    if(tempdir[0] != '\0'){
-      DIR *d;
-      struct dirent *direntry;
-      d = opendir(tempdir);
-      if(d == NULL){
-	perror("opendir");
-      } else {
-	while(true){
-	  direntry = readdir(d);
-	  if(direntry == NULL){
-	    break;
-	  }
-	  if (direntry->d_type == DT_REG){
-	    char *fullname = NULL;
-	    ret = asprintf(&fullname, "%s/%s", tempdir,
-			   direntry->d_name);
-	    if(ret < 0){
-	      perror("asprintf");
-	      continue;
-	    }
-	    ret = unlink(fullname);
-	    if(ret == -1){
-	      fprintf(stderr, "unlink(\"%s\"): %s",
-		      fullname, strerror(errno));
-	    }
-	    free(fullname);
-	  }
-	}
-	closedir(d);
-      }
-      ret = rmdir(tempdir);
-      if(ret == -1){
-	perror("rmdir");
-      }
-    }
-	  
+    }
+    
     return exitcode;
 }

=== renamed file 'plugins.d/mandos-client.xml' => 'plugins.d/password-request.xml'
--- plugins.d/mandos-client.xml	2008-09-12 19:12:40 +0000
+++ plugins.d/password-request.xml	2008-09-03 05:12:45 +0000
@@ -2,8 +2,8 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY VERSION "1.0">
-<!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2008-09-12">
+<!ENTITY COMMANDNAME "password-request">
+<!ENTITY TIMESTAMP "2008-09-03">
 ]>
 
 <refentry xmlns:xi="http://www.w3.org/2001/XInclude">
@@ -36,7 +36,7 @@
     </copyright>
     <xi:include href="../legalnotice.xml"/>
   </refentryinfo>
-  
+
   <refmeta>
     <refentrytitle>&COMMANDNAME;</refentrytitle>
     <manvolnum>8mandos</manvolnum>
@@ -45,23 +45,30 @@
   <refnamediv>
     <refname><command>&COMMANDNAME;</command></refname>
     <refpurpose>
-      Client for <application>Mandos</application>
+      Client for mandos
     </refpurpose>
   </refnamediv>
-  
+
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
       <group>
 	<arg choice="plain"><option>--connect
-	<replaceable>ADDRESS</replaceable><literal>:</literal
+	<replaceable>IPADDR</replaceable><literal>:</literal
 	><replaceable>PORT</replaceable></option></arg>
 	<arg choice="plain"><option>-c
-	<replaceable>ADDRESS</replaceable><literal>:</literal
+	<replaceable>IPADDR</replaceable><literal>:</literal
 	><replaceable>PORT</replaceable></option></arg>
       </group>
       <sbr/>
       <group>
+	<arg choice="plain"><option>--keydir
+	<replaceable>DIRECTORY</replaceable></option></arg>
+	<arg choice="plain"><option>-d
+	<replaceable>DIRECTORY</replaceable></option></arg>
+      </group>
+      <sbr/>
+      <group>
 	<arg choice="plain"><option>--interface
 	<replaceable>NAME</replaceable></option></arg>
 	<arg choice="plain"><option>-i
@@ -113,7 +120,7 @@
       </group>
     </cmdsynopsis>
   </refsynopsisdiv>
-  
+
   <refsect1 id="description">
     <title>DESCRIPTION</title>
     <para>
@@ -124,7 +131,7 @@
       network connectivity, Zeroconf to find servers, and TLS with an
       OpenPGP key to ensure authenticity and confidentiality.  It
       keeps running, trying all servers on the network, until it
-      receives a satisfactory reply or a TERM signal is received.
+      receives a satisfactory reply or a TERM signal is recieved.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -184,6 +191,22 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--keydir=<replaceable
+	>DIRECTORY</replaceable></option></term>
+	<term><option>-d
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Directory to read the OpenPGP key files
+	    <filename>pubkey.txt</filename> and
+	    <filename>seckey.txt</filename> from.  The default is
+	    <filename>/conf/conf.d/mandos</filename> (in the initial
+	    <acronym>RAM</acronym> disk environment).
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
 	<term><option>--interface=
 	<replaceable>NAME</replaceable></option></term>
 	<term><option>-i
@@ -194,11 +217,6 @@
 	    Mandos servers to connect to.  The default it
 	    <quote><literal>eth0</literal></quote>.
 	  </para>
-	  <para>
-	    If the <option>--connect</option> option is used, this
-	    specifies the interface to use to connect to the address
-	    given.
-	  </para>
 	</listitem>
       </varlistentry>
       
@@ -209,13 +227,14 @@
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP public key file name.  The default name is
-	    <quote><filename>/conf/conf.d/mandos/pubkey.txt</filename
-	    ></quote>.
+	    OpenPGP public key file base name.  This will be combined
+	    with the directory from the <option>--keydir</option>
+	    option to form an absolute file name.  The default name is
+	    <quote><literal>pubkey.txt</literal></quote>.
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--seckey=<replaceable
 	>FILE</replaceable></option></term>
@@ -223,9 +242,10 @@
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP secret key file name.  The default name is
-	    <quote><filename>/conf/conf.d/mandos/seckey.txt</filename
-	    ></quote>.
+	    OpenPGP secret key file base name.  This will be combined
+	    with the directory from the <option>--keydir</option>
+	    option to form an absolute file name.  The default name is
+	    <quote><literal>seckey.txt</literal></quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -238,7 +258,7 @@
 		      xpointer="priority"/>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--dh-bits=<replaceable
 	>BITS</replaceable></option></term>
@@ -284,7 +304,7 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      
+
       <varlistentry>
 	<term><option>--version</option></term>
 	<term><option>-V</option></term>
@@ -296,7 +316,7 @@
       </varlistentry>
     </variablelist>
   </refsect1>
-  
+
   <refsect1 id="overview">
     <title>OVERVIEW</title>
     <xi:include href="../overview.xml"/>
@@ -311,12 +331,8 @@
       <filename>/etc/crypttab</filename>, but it would then be
       impossible to enter a password for the encrypted root disk at
       the console, since this program does not read from the console
-      at all.  This is why a separate plugin runner (<citerefentry>
-      <refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>) is used to run
-      both this program and others in in parallel,
-      <emphasis>one</emphasis> of which will prompt for passwords on
-      the system console.
+      at all.  This is why a separate plugin does that, which will be
+      run in parallell to this one by the plugin runner.
     </para>
   </refsect1>
   
@@ -329,7 +345,7 @@
       program will exit with a non-zero exit status only if a critical
       error occurs.  Otherwise, it will forever connect to new
       <application>Mandos</application> servers as they appear, trying
-      to get a decryptable password and print it.
+      to get a decryptable password.
     </para>
   </refsect1>
   
@@ -345,139 +361,31 @@
   
   <refsect1 id="file">
     <title>FILES</title>
-    <variablelist>
-      <varlistentry>
-	<term><filename>/conf/conf.d/mandos/pubkey.txt</filename
-	></term>
-	<term><filename>/conf/conf.d/mandos/seckey.txt</filename
-	></term>
-	<listitem>
-	  <para>
-	    OpenPGP public and private key files, in <quote>ASCII
-	    Armor</quote> format.  These are the default file names,
-	    they can be changed with the <option>--pubkey</option> and
-	    <option>--seckey</option> options.
-	  </para>
-	</listitem>
-      </varlistentry>
-    </variablelist>
-  </refsect1>
-  
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
-  
+    <para>
+    </para>
+  </refsect1>
+  
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <para>
+    </para>
+  </refsect1>
+
   <refsect1 id="example">
     <title>EXAMPLE</title>
     <para>
-      Note that normally, command line options will not be given
-      directly, but via options for the Mandos <citerefentry
-      ><refentrytitle>plugin-runner</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.
     </para>
-    <informalexample>
-      <para>
-	Normal invocation needs no options, if the network interface
-	is <quote>eth0</quote>:
-      </para>
-      <para>
-	<userinput>&COMMANDNAME;</userinput>
-      </para>
-    </informalexample>
-    <informalexample>
-      <para>
-	Search for Mandos servers (and connect to them) using another
-	interface:
-      </para>
-      <para>
-	<!-- do not wrap this line -->
-	<userinput>&COMMANDNAME; --interface eth1</userinput>
-      </para>
-    </informalexample>
-    <informalexample>
-      <para>
-	Run in debug mode, and use a custom key:
-      </para>
-      <para>
-
-<!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt</userinput>
-
-      </para>
-    </informalexample>
-    <informalexample>
-      <para>
-	Run in debug mode, with a custom key, and do not use Zeroconf
-	to locate a server; connect directly to the IPv6 address
-	<quote><systemitem class="ipaddress"
-	>2001:db8:f983:bd0b:30de:ae4a:71f2:f672</systemitem></quote>,
-	port 4711, using interface eth2:
-      </para>
-      <para>
-
-<!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --connect 2001:db8:f983:bd0b:30de:ae4a:71f2:f672:4711 --interface eth2</userinput>
-
-      </para>
-    </informalexample>
   </refsect1>
-  
+
   <refsect1 id="security">
     <title>SECURITY</title>
     <para>
-      This program is set-uid to root, but will switch back to the
-      original (and presumably non-privileged) user and group after
-      bringing up the network interface.
-    </para>
-    <para>
-      To use this program for its intended purpose (see <xref
-      linkend="purpose"/>), the password for the root file system will
-      have to be given out to be stored in a server computer, after
-      having been encrypted using an OpenPGP key.  This encrypted data
-      which will be stored in a server can only be decrypted by the
-      OpenPGP key, and the data will only be given out to those
-      clients who can prove they actually have that key.  This key,
-      however, is stored unencrypted on the client side in its initial
-      <acronym>RAM</acronym> disk image file system.  This is normally
-      readable by all, but this is normally fixed during installation
-      of this program; file permissions are set so that no-one is able
-      to read that file.
-    </para>
-    <para>
-      The only remaining weak point is that someone with physical
-      access to the client hard drive might turn off the client
-      computer, read the OpenPGP keys directly from the hard drive,
-      and communicate with the server.  The defense against this is
-      that the server is supposed to notice the client disappearing
-      and will stop giving out the encrypted data.  Therefore, it is
-      important to set the timeout and checker interval values tightly
-      on the server.  See <citerefentry><refentrytitle
-      >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>.
-    </para>
-    <para>
-      It will also help if the checker program on the server is
-      configured to request something from the client which can not be
-      spoofed by someone else on the network, unlike unencrypted
-      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
-    </para>
-    <para>
-      <emphasis>Note</emphasis>: This makes it completely insecure to
-      have <application >Mandos</application> clients which dual-boot
-      to another operating system which is <emphasis>not</emphasis>
-      trusted to keep the initial <acronym>RAM</acronym> disk image
-      confidential.
     </para>
   </refsect1>
-  
+
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
-      <citerefentry><refentrytitle>cryptsetup</refentrytitle>
-      <manvolnum>8</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>crypttab</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>password-prompt</refentrytitle>
@@ -485,124 +393,45 @@
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
-    <variablelist>
-      <varlistentry>
-	<term>
-	  <ulink url="http://www.zeroconf.org/">Zeroconf</ulink>
-	</term>
-	<listitem>
-	  <para>
-	    Zeroconf is the network protocol standard used for finding
-	    Mandos servers on the local network.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  <ulink url="http://www.avahi.org/">Avahi</ulink>
-	</term>
-      <listitem>
-	<para>
-	  Avahi is the library this program calls to find Zeroconf
-	  services.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  <ulink url="http://www.gnu.org/software/gnutls/"
-	  >GnuTLS</ulink>
-	</term>
-      <listitem>
-	<para>
-	  GnuTLS is the library this client uses to implement TLS for
-	  communicating securely with the server, and at the same time
-	  send the public OpenPGP key to the server.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  <ulink url="http://www.gnupg.org/related_software/gpgme/"
-		 >GPGME</ulink>
-	</term>
-	<listitem>
-	  <para>
-	    GPGME is the library used to decrypt the OpenPGP data sent
-	    by the server.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  RFC 4291: <citetitle>IP Version 6 Addressing
-	  Architecture</citetitle>
-	</term>
-	<listitem>
-	  <variablelist>
-	    <varlistentry>
-	      <term>Section 2.2: <citetitle>Text Representation of
-	      Addresses</citetitle></term>
-	      <listitem><para/></listitem>
-	    </varlistentry>
-	    <varlistentry>
-	      <term>Section 2.5.5.2: <citetitle>IPv4-Mapped IPv6
-	      Address</citetitle></term>
-	      <listitem><para/></listitem>
-	    </varlistentry>
-	    <varlistentry>
-	    <term>Section 2.5.6, <citetitle>Link-Local IPv6 Unicast
-	    Addresses</citetitle></term>
-	    <listitem>
-	      <para>
-		This client uses IPv6 link-local addresses, which are
-		immediately usable since a link-local addresses is
-		automatically assigned to a network interfaces when it
-		is brought up.
-	      </para>
-	    </listitem>
-	    </varlistentry>
-	  </variablelist>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.1</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  TLS 1.1 is the protocol implemented by GnuTLS.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  RFC 4880: <citetitle>OpenPGP Message Format</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  The data received from the server is binary encrypted
-	  OpenPGP data.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
-	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
-	  Security</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  This is implemented by GnuTLS and used by this program so
-	  that OpenPGP keys can be used.
-	</para>
-      </listitem>
-      </varlistentry>
-    </variablelist>
+    <itemizedlist>
+      <listitem><para>
+	<ulink url="http://www.zeroconf.org/">Zeroconf</ulink>
+      </para></listitem>
+      
+      <listitem><para>
+	<ulink url="http://www.avahi.org/">Avahi</ulink>
+      </para></listitem>
+      
+      <listitem><para>
+	<ulink
+	    url="http://www.gnu.org/software/gnutls/">GnuTLS</ulink>
+      </para></listitem>
+      
+      <listitem><para>
+	<ulink
+	url="http://www.gnupg.org/related_software/gpgme/"
+	>GPGME</ulink>
+      </para></listitem>
+      
+      <listitem><para>
+	<citation>RFC 4880: <citetitle>OpenPGP Message
+	Format</citetitle></citation>
+      </para></listitem>
+      
+      <listitem><para>
+	<citation>RFC 5081: <citetitle>Using OpenPGP Keys for
+	Transport Layer Security</citetitle></citation>
+      </para></listitem>
+      
+      <listitem><para>
+	<citation>RFC 4291: <citetitle>IP Version 6 Addressing
+	Architecture</citetitle>, section 2.5.6, Link-Local IPv6
+	Unicast Addresses</citation>
+      </para></listitem>
+    </itemizedlist>
   </refsect1>
+
 </refentry>
-
 <!-- Local Variables: -->
 <!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
 <!-- time-stamp-end: "[\"']>" -->

